/*
 * 
 * (C) Alvaro Corts. 2007. alvarocortesc@gmail.com
 * 
 * Alertas.cs.
 * 
 * Registra las alertas 
 * 
 */

using System;
using MySql.Data.MySqlClient;


namespace FormulacionMagistral
{
	/// <summary>
	/// Description of Alertas.
	/// </summary>
	public class Alertas
	{
		
		private	MySqlConnection conexion;
     	private string cadenaConexion;
		
		/// <summary>
		/// Contructor de la clase
		/// </summary>
		public Alertas()
		{
		}
		
		#region Asignadores de propiedades

		/// <summary>
		/// Asigna lo parametros de conexion con la base de datos
		/// para la autentificacion de usuario.
		/// </summary>
		/// <param name="host">Nombre o IP del servidor</param>
		/// <param name="port">Puerto de conexion</param> 
		/// <param name="user">Usuario de la BD</param>
		/// <param name="passwd">Password para el usuario</param>
		/// <param name="database">Base de datos del servidor</param>
		/// <returns>Devuelve nada.</returns>
		public void setConnectionParameters(string host, string port, string user, string passwd, string database){
		cadenaConexion = "server="+host+";port="+ port +";user id="+user+";password="+passwd + ";database="+database+";pooling=false";
		}

		#endregion
		
		
				#region Mtodo publicos

		/// <summary>
		/// Establece la conexion con la base de datos segun los 
		/// parametros asignados.
		/// </summary>
		/// <returns>Devuelve true si no hay error o false si existe algun problema</returns>
		private bool conectar(){
			try{
			conexion = new MySqlConnection(cadenaConexion);
			conexion.Open();
			return true;
			}catch(Exception e){
			FM_Errores.MostrarError("conectar","No se puede establecer la conexion con la base de datos",e);
			return false;
			}
		}

		/// <summary>
		/// Desconecta del servidor
		/// </summary>

		private void desconectar(){
			conexion.Close();
		}

		
		/// <summary>
		/// Registra la alerta de contenido especificado
		/// </summary>
		/// <param name="contenido">Mensaje a registrar</param>
		/// <returns>Devuelve verdadero si ha tenido exito</returns>
		public bool registra_alerta(string contenido){
			
		MySqlCommand MyCmd;

		DateTime fecha= new DateTime();
		fecha=DateTime.Now;
		
		try{
		if( this.conectar() )
		{
		contenido.Replace("\'","");
		MyCmd = new MySqlCommand("INSERT INTO alertas (fecha, contenido) VALUES ('" + fecha.ToString() + "','" + contenido +"')",conexion);
		MyCmd.ExecuteNonQuery();
		this.desconectar();
		return true;
		}else{
		return false;
		}
		}catch(MySqlException e){
			FM_Errores.MostrarError("Registra_login","Error relacionado con la base de datos",e);
			return false;
		}catch(Exception err){
			FM_Errores.MostrarError("Registra_login","Error registrando el usuario conectado",err);
			return false;
		}


		}
		#endregion
		
		
		
	}
}
