/*
 * 
 * Editor de prospectos, etiquetas,etc..
 * 
 * (C) Alvaro Cortes. 2007. alvarocortesc@gmail.com
 * 
 * 
 * 
 */

using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Printing;

namespace FormulacionMagistral
{
	/// <summary>
	/// Description of Editor.
	/// </summary>
	public class Editor : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton btnBarGuardar;
		private System.Windows.Forms.RichTextBox richEditor;
		private System.Windows.Forms.ToolBarButton btnBarNegro;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBarButton btnBarNuevo;
		private System.Windows.Forms.ToolBarButton btnBarCursiva;
		private System.Windows.Forms.ToolBarButton btnBarSub;
		private System.Windows.Forms.ToolBarButton btnBarAbrir;
		
		/// <summary>
		/// Constructor
		/// </summary>
		public Editor()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
		}
		
		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="fichero">Fichero a cargar</param>
		public Editor(string fichero)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			richEditor.LoadFile(fichero);
		}
		
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Editor));
			this.btnBarAbrir = new System.Windows.Forms.ToolBarButton();
			this.btnBarSub = new System.Windows.Forms.ToolBarButton();
			this.btnBarCursiva = new System.Windows.Forms.ToolBarButton();
			this.btnBarNuevo = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.btnBarNegro = new System.Windows.Forms.ToolBarButton();
			this.richEditor = new System.Windows.Forms.RichTextBox();
			this.btnBarGuardar = new System.Windows.Forms.ToolBarButton();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.SuspendLayout();
			// 
			// btnBarAbrir
			// 
			this.btnBarAbrir.ImageIndex = 1;
			this.btnBarAbrir.Text = "Abrir";
			this.btnBarAbrir.ToolTipText = "Abrir un documento rtf";
			// 
			// btnBarSub
			// 
			this.btnBarSub.ImageIndex = 5;
			this.btnBarSub.Text = "Subrayar";
			this.btnBarSub.ToolTipText = "Subrayar";
			// 
			// btnBarCursiva
			// 
			this.btnBarCursiva.ImageIndex = 4;
			this.btnBarCursiva.Text = "Cursiva";
			this.btnBarCursiva.ToolTipText = "Cursiva";
			// 
			// btnBarNuevo
			// 
			this.btnBarNuevo.ImageIndex = 0;
			this.btnBarNuevo.Text = "Nuevo";
			this.btnBarNuevo.ToolTipText = "Nuevo documento";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// btnBarNegro
			// 
			this.btnBarNegro.ImageIndex = 3;
			this.btnBarNegro.Text = "Resaltar";
			this.btnBarNegro.ToolTipText = "Resaltar";
			// 
			// richEditor
			// 
			this.richEditor.Location = new System.Drawing.Point(0, 40);
			this.richEditor.Name = "richEditor";
			this.richEditor.Size = new System.Drawing.Size(688, 320);
			this.richEditor.TabIndex = 0;
			this.richEditor.Text = "Editor";
			this.richEditor.TextChanged += new System.EventHandler(this.RichEditorTextChanged);
			// 
			// btnBarGuardar
			// 
			this.btnBarGuardar.ImageIndex = 2;
			this.btnBarGuardar.Text = "Guardar";
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
						this.btnBarNuevo,
						this.btnBarAbrir,
						this.btnBarGuardar,
						this.btnBarNegro,
						this.btnBarCursiva,
						this.btnBarSub});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(688, 42);
			this.toolBar1.TabIndex = 1;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.ToolBar1ButtonClick);
			// 
			// Editor
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 365);
			this.Controls.Add(this.toolBar1);
			this.Controls.Add(this.richEditor);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "Editor";
			this.Text = "Editor";
			this.ResumeLayout(false);
		}
		#endregion
		void ToolBar1ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			try{
			if ( e.Button.Text.CompareTo("Nuevo") == 0 )
			{
				richEditor.Clear();
			}else if(e.Button.Text.CompareTo("Abrir") == 0){
				
				System.Windows.Forms.OpenFileDialog op1 = new OpenFileDialog();
				if ( op1.ShowDialog() == System.Windows.Forms.DialogResult.OK){
					if( op1.FileName != null && op1.FileName.Length > 0)
					richEditor.LoadFile(op1.FileName);
				}
                
			}else if(e.Button.Text.CompareTo("Resaltar") == 0){
				
				if (richEditor.SelectionFont != null)
   				{
      				System.Drawing.Font currentFont = richEditor.SelectionFont;
      				System.Drawing.FontStyle newFontStyle;

      			if (richEditor.SelectionFont.Bold == true)
      			{
         			newFontStyle = FontStyle.Regular;
      			}
      			else
      			{
         			newFontStyle = FontStyle.Bold;
      			}

		      	richEditor.SelectionFont = new Font(currentFont.FontFamily, 
         											currentFont.Size, 
         											newFontStyle);
			  }
			}else if(e.Button.Text.CompareTo("Subrayar") == 0){
				
				if (richEditor.SelectionFont != null)
   				{
      				System.Drawing.Font currentFont = richEditor.SelectionFont;
      				System.Drawing.FontStyle newFontStyle;

      			if (richEditor.SelectionFont.Underline == true)
      			{
         			newFontStyle = FontStyle.Regular;
      			}
      			else
      			{
         			newFontStyle = FontStyle.Underline;
      			}

		      	richEditor.SelectionFont = new Font(currentFont.FontFamily, 
         											currentFont.Size, 
         											newFontStyle);
			  }
			}else if(e.Button.Text.CompareTo("Cursiva") == 0){
				
				if (richEditor.SelectionFont != null)
   				{
      				System.Drawing.Font currentFont = richEditor.SelectionFont;
      				System.Drawing.FontStyle newFontStyle;

      			if (richEditor.SelectionFont.Italic == true)
      			{
         			newFontStyle = FontStyle.Regular;
      			}
      			else
      			{
         			newFontStyle = FontStyle.Italic;
      			}

		      	richEditor.SelectionFont = new Font(currentFont.FontFamily, 
         											currentFont.Size, 
         											newFontStyle);
			  }
			}else if(e.Button.Text.CompareTo("Guardar") == 0){
				string ef;
				System.Windows.Forms.SaveFileDialog sv = new SaveFileDialog();
				if ( sv.ShowDialog() == System.Windows.Forms.DialogResult.OK){
                	ef = sv.FileName;
					if (ef == null || ef.Length < 1) 
            			return;
					
					richEditor.SaveFile(ef);
					
				}
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("Editor","El editor no puede ejecutar el comando solicitado",ex);
			}
		}
		
		
		void RichEditorTextChanged(object sender, System.EventArgs e)
		{
			
		}
		
	}
}
