/*
 * 
 * Formulario de entrada generica
 * 
 * 
 * 
 * (C) Alvaro Cortes. 2007. alvarocortesc@gmail.com
 * 
 * 
 * 
 * 
 */

using System;
using System.Drawing;
using System.Windows.Forms;

namespace FormulacionMagistral
{
	/// <summary>
	/// Description of GenericInputForm.
	/// </summary>
	public class GenericInputForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Label lblQuestion;
		private System.Windows.Forms.TextBox txtInput;
		private System.Windows.Forms.Button btnCancel;
		
		/// <summary>
		/// Contenido de entrada
		/// </summary>
		public string answer;
		/// <summary>
		/// Resultado de la pregunta. 0 cancelar. 1 aceptar.
		/// </summary>
		public int result;

		/// <summary>
		/// Contructor
		/// </summary>
		/// <param name="title">Titulo del dialogo</param>
		/// <param name="text">Texto a preguntar</param>
		/// <param name="opaque">Caracter para ocultar el texto</param>
		public GenericInputForm(string title, string text, char opaque)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
		
			this.lblQuestion.Text = text;
			this.Text = title;
			this.txtInput.PasswordChar = opaque;
			
		}

		
		/// <summary>
		/// Contructor
		/// </summary>
		/// <param name="title">Titulo del dialogo</param>
		/// <param name="text">Pregunta de entrada</param>
		public GenericInputForm(string title, string text)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
		
			this.lblQuestion.Text = text;
			this.Text = title;
			
		}
		
		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="text">Pregunta de entrada</param>
		public GenericInputForm(string text)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
		
			this.lblQuestion.Text = text;
			this.Text = "Entrada de datos";
			
		}

		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.btnCancel = new System.Windows.Forms.Button();
			this.txtInput = new System.Windows.Forms.TextBox();
			this.lblQuestion = new System.Windows.Forms.Label();
			this.btnOK = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(248, 56);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(168, 24);
			this.btnCancel.TabIndex = 3;
			this.btnCancel.Text = "Cancelar";
			this.btnCancel.Click += new System.EventHandler(this.BtnCancelClick);
			// 
			// txtInput
			// 
			this.txtInput.Location = new System.Drawing.Point(160, 16);
			this.txtInput.Name = "txtInput";
			this.txtInput.Size = new System.Drawing.Size(264, 20);
			this.txtInput.TabIndex = 1;
			this.txtInput.Text = "";
			// 
			// lblQuestion
			// 
			this.lblQuestion.Location = new System.Drawing.Point(16, 24);
			this.lblQuestion.Name = "lblQuestion";
			this.lblQuestion.Size = new System.Drawing.Size(120, 16);
			this.lblQuestion.TabIndex = 0;
			this.lblQuestion.Text = "Input";
			// 
			// btnOK
			// 
			this.btnOK.Location = new System.Drawing.Point(56, 56);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(168, 24);
			this.btnOK.TabIndex = 2;
			this.btnOK.Text = "Aceptar";
			this.btnOK.Click += new System.EventHandler(this.BtnOKClick);
			// 
			// GenericInputForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(434, 90);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.txtInput);
			this.Controls.Add(this.lblQuestion);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "GenericInputForm";
			this.Text = "GenericInputForm";
			this.ResumeLayout(false);
		}
		#endregion
		void BtnOKClick(object sender, System.EventArgs e)
		{
			this.answer = this.txtInput.Text;
			this.result = 1;
			this.Close();
		}
		
		void BtnCancelClick(object sender, System.EventArgs e)
		{
			this.answer = this.txtInput.Text;
			this.result = 0;
			this.Close();
		}
		
	}
}
