/*
 * LoginForm
 * 
 * Formulario de login de la aplicacin
 * 
 * (C) 2006. Alvaro Cortes
 * 
 * Formulacin Magistral
 */

using System;
using System.Drawing;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FormulacionMagistral
{
	/// <summary>
	/// Description of LoginForm.
	/// </summary>
	public class LoginForm : System.Windows.Forms.Form 
	{
		private System.Windows.Forms.Button btnLogin;
		private System.Windows.Forms.PictureBox pctLogoLogin;
		private System.Windows.Forms.ListBox lstUsersLogin;
		private System.Windows.Forms.GroupBox grpInfoLogin;
		private System.Windows.Forms.Button btnAyuda;
		private System.Windows.Forms.Label lblInfoLogin;
		private System.Windows.Forms.Label lblUserLogin;
		private System.Windows.Forms.GroupBox grpUsersLogin;
		private System.Windows.Forms.Label lblPasswdLogin;
		private System.Windows.Forms.Button btnSalir;
		private System.Windows.Forms.TextBox txtPasswdLogin;
		private System.Windows.Forms.TextBox txtUserLogin;
		
		private string dbhost; 
		private string dbport;
		private string dbuser;
		private string dbpasoteword;
		
		private int currentid;
		
		private Formulacion.PreferenciasDB DBPrefs;
		private Formulacion.FarmaAuthorize SecLocal;
		private Alertas AlertaLocal; // Alertas
		
		/// <summary>
		/// Determina si se ha entrado en el sistema o no
		/// </summary>
		public bool login_ok;
		
		#region Constructor
		/// <summary>
		/// Constructor de la clase
		/// </summary>
		/// <param name="appid">Instancia de la aplicacin</param>
		public LoginForm(int appid)
		{
			this.currentid = appid;
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			
			SecLocal = new Formulacion.FarmaAuthorize();
			AlertaLocal = new Alertas();
		}
		#endregion
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.txtUserLogin = new System.Windows.Forms.TextBox();
			this.txtPasswdLogin = new System.Windows.Forms.TextBox();
			this.btnSalir = new System.Windows.Forms.Button();
			this.lblPasswdLogin = new System.Windows.Forms.Label();
			this.grpUsersLogin = new System.Windows.Forms.GroupBox();
			this.lblUserLogin = new System.Windows.Forms.Label();
			this.lblInfoLogin = new System.Windows.Forms.Label();
			this.btnAyuda = new System.Windows.Forms.Button();
			this.grpInfoLogin = new System.Windows.Forms.GroupBox();
			this.lstUsersLogin = new System.Windows.Forms.ListBox();
			this.pctLogoLogin = new System.Windows.Forms.PictureBox();
			this.btnLogin = new System.Windows.Forms.Button();
			this.grpUsersLogin.SuspendLayout();
			this.grpInfoLogin.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtUserLogin
			// 
			this.txtUserLogin.Location = new System.Drawing.Point(120, 24);
			this.txtUserLogin.Name = "txtUserLogin";
			this.txtUserLogin.Size = new System.Drawing.Size(152, 20);
			this.txtUserLogin.TabIndex = 1;
			this.txtUserLogin.Text = "";
			// 
			// txtPasswdLogin
			// 
			this.txtPasswdLogin.Location = new System.Drawing.Point(304, 128);
			this.txtPasswdLogin.Name = "txtPasswdLogin";
			this.txtPasswdLogin.PasswordChar = '*';
			this.txtPasswdLogin.Size = new System.Drawing.Size(152, 20);
			this.txtPasswdLogin.TabIndex = 2;
			this.txtPasswdLogin.Text = "";
			// 
			// btnSalir
			// 
			this.btnSalir.Location = new System.Drawing.Point(128, 152);
			this.btnSalir.Name = "btnSalir";
			this.btnSalir.Size = new System.Drawing.Size(72, 32);
			this.btnSalir.TabIndex = 6;
			this.btnSalir.TabStop = false;
			this.btnSalir.Text = "Salir";
			this.btnSalir.Click += new System.EventHandler(this.BtnSalirClick);
			// 
			// lblPasswdLogin
			// 
			this.lblPasswdLogin.Location = new System.Drawing.Point(208, 128);
			this.lblPasswdLogin.Name = "lblPasswdLogin";
			this.lblPasswdLogin.Size = new System.Drawing.Size(80, 16);
			this.lblPasswdLogin.TabIndex = 5;
			this.lblPasswdLogin.Text = "Password:";
			// 
			// grpUsersLogin
			// 
			this.grpUsersLogin.Controls.Add(this.lstUsersLogin);
			this.grpUsersLogin.Controls.Add(this.pctLogoLogin);
			this.grpUsersLogin.Location = new System.Drawing.Point(8, 56);
			this.grpUsersLogin.Name = "grpUsersLogin";
			this.grpUsersLogin.Size = new System.Drawing.Size(152, 232);
			this.grpUsersLogin.TabIndex = 8;
			this.grpUsersLogin.TabStop = false;
			this.grpUsersLogin.Text = "Lista usuarios";
			// 
			// lblUserLogin
			// 
			this.lblUserLogin.Location = new System.Drawing.Point(24, 24);
			this.lblUserLogin.Name = "lblUserLogin";
			this.lblUserLogin.Size = new System.Drawing.Size(72, 16);
			this.lblUserLogin.TabIndex = 4;
			this.lblUserLogin.Text = "Usuario:";
			// 
			// lblInfoLogin
			// 
			this.lblInfoLogin.Location = new System.Drawing.Point(64, 8);
			this.lblInfoLogin.Name = "lblInfoLogin";
			this.lblInfoLogin.Size = new System.Drawing.Size(384, 16);
			this.lblInfoLogin.TabIndex = 6;
			this.lblInfoLogin.Text = "Por favor seleccione su usario e introduzca su contrasea";
			// 
			// btnAyuda
			// 
			this.btnAyuda.Location = new System.Drawing.Point(224, 152);
			this.btnAyuda.Name = "btnAyuda";
			this.btnAyuda.Size = new System.Drawing.Size(64, 32);
			this.btnAyuda.TabIndex = 7;
			this.btnAyuda.TabStop = false;
			this.btnAyuda.Text = "Ayuda";
			this.btnAyuda.Click += new System.EventHandler(this.BtnAyudaClick);
			// 
			// grpInfoLogin
			// 
			this.grpInfoLogin.Controls.Add(this.btnAyuda);
			this.grpInfoLogin.Controls.Add(this.btnSalir);
			this.grpInfoLogin.Controls.Add(this.btnLogin);
			this.grpInfoLogin.Controls.Add(this.txtUserLogin);
			this.grpInfoLogin.Controls.Add(this.lblUserLogin);
			this.grpInfoLogin.Location = new System.Drawing.Point(184, 56);
			this.grpInfoLogin.Name = "grpInfoLogin";
			this.grpInfoLogin.Size = new System.Drawing.Size(304, 232);
			this.grpInfoLogin.TabIndex = 7;
			this.grpInfoLogin.TabStop = false;
			this.grpInfoLogin.Text = "Datos usuario";
			// 
			// lstUsersLogin
			// 
			this.lstUsersLogin.Location = new System.Drawing.Point(16, 24);
			this.lstUsersLogin.Name = "lstUsersLogin";
			this.lstUsersLogin.Size = new System.Drawing.Size(120, 95);
			this.lstUsersLogin.TabIndex = 3;
			this.lstUsersLogin.SelectedIndexChanged += new System.EventHandler(this.LstUsersLoginSelectedIndexChanged);
			// 
			// pctLogoLogin
			// 
			this.pctLogoLogin.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pctLogoLogin.Location = new System.Drawing.Point(24, 136);
			this.pctLogoLogin.Name = "pctLogoLogin";
			this.pctLogoLogin.Size = new System.Drawing.Size(104, 88);
			this.pctLogoLogin.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pctLogoLogin.TabIndex = 0;
			this.pctLogoLogin.TabStop = false;
			// 
			// btnLogin
			// 
			this.btnLogin.Location = new System.Drawing.Point(32, 152);
			this.btnLogin.Name = "btnLogin";
			this.btnLogin.Size = new System.Drawing.Size(72, 32);
			this.btnLogin.TabIndex = 5;
			this.btnLogin.TabStop = false;
			this.btnLogin.Text = "Login";
			this.btnLogin.Click += new System.EventHandler(this.BtnLoginClick);
			// 
			// LoginForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(512, 296);
			this.ControlBox = false;
			this.Controls.Add(this.lblInfoLogin);
			this.Controls.Add(this.lblPasswdLogin);
			this.Controls.Add(this.txtPasswdLogin);
			this.Controls.Add(this.grpInfoLogin);
			this.Controls.Add(this.grpUsersLogin);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "LoginForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Formulacin Magistral - Login";
			this.Load += new System.EventHandler(this.LoginFormLoad);
			this.grpUsersLogin.ResumeLayout(false);
			this.grpInfoLogin.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion
		
		#region Carga de configuracin
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}
		#endregion
		
		#region Carga de informacin de la base de datos
		void CargarNombresUsuarios()
		{
			string [] usuarios;
			usuarios = SecLocal.GetUsersList();
			for(int i = 0; i < usuarios.Length; ++i)
				this.lstUsersLogin.Items.Add(usuarios[i]);
			
		}
		
		
		void CargarInformacionUsuarios(string username){
			MySqlConnection conn = new MySqlConnection("host="+this.dbhost+";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");
			MySqlDataReader MyReader = null;
			try 
			{
			MySqlCommand cmd = new MySqlCommand("SELECT * FROM personal WHERE Usuario LIKE '"+username+"'", conn);
			
			conn.Open();
				MyReader = cmd.ExecuteReader();
				while( MyReader.Read() )
				{
					this.txtUserLogin.Text   = MyReader.GetString(4);
					
					if( System.IO.File.Exists(MyReader.GetString(6)) )
					this.pctLogoLogin.Image = Image.FromFile(MyReader.GetString(6));
					else
						this.pctLogoLogin.Image = null;
						//this.cmbTipoUser.Text = CargarTipoUsuario(MyReader.GetString(1));
				}
				MyReader.Close();
				conn.Close();
		
			}
			catch (MySqlException ex) 
			{
				FM_Errores.MostrarError("MainForm","No se puede conectar con la base de datos para conseguir la lista de usuarios",ex);
				return;
			}catch( Exception e){
				FM_Errores.MostrarError("MainForm","No se puede conectar con la base de datos para conseguir la lista de usuarios",e);
				return;
			}
		}
		
		#endregion
		
		
		
		void LoginFormLoad(object sender, System.EventArgs e)
		{
			this.login_ok = false;
			this.CargarConfiguracionDatabase();
			SecLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
			AlertaLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
			//SecLocal.CreateNewUser("test2","test2","user1.jpg",2,"Pepe","Gmez Prez","20-20-2111");

			this.CargarNombresUsuarios();
		}
		
		
		void BtnSalirClick(object sender, System.EventArgs e)
		{
			Application.Exit();
		}
		
		void LstUsersLoginSelectedIndexChanged(object sender, System.EventArgs e)
		{
			if ( this.lstUsersLogin.SelectedIndex >= 0)
			CargarInformacionUsuarios(this.lstUsersLogin.SelectedItem.ToString());
		}
		
		void BtnLoginClick(object sender, System.EventArgs e)
		{
			if ( SecLocal.login( this.txtUserLogin.Text, this.txtPasswdLogin.Text, this.currentid ) ){
				this.login_ok = true;
				this.Close();
			}

			else{
				if( !AlertaLocal.registra_alerta("La instancia " + this.currentid.ToString() + " registra un intento fallido de entra al sistema con el nombre de usuario "+this.txtUserLogin.Text))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}
				FM_Errores.MostrarError("Fallo Login","Error en nombre de usuario o contrasea");
			}
			
		}
		
		void BtnAyudaClick(object sender, System.EventArgs e)
		{
			FormulacionMagistral.HelpDetail hd = new FormulacionMagistral.HelpDetail("Login");
			hd.ShowDialog();
			hd.Dispose();

		}
		
	}
}
