/*
 * 
 * (C) Alvaro Cortes. 2007. alvarocortesc@gmail.com
 * 
 * Formulario Principal de la aplicacion Formulacion Magistral
 * 
 * 
 * Contiene los modulos de:
 *  
 * - Control de calidad
 * - Materias Primas
 * - Gestion de Personal
 * - Material de Acondicionamiento
 * 
 * Y permite acceder al resto de modulos: configuracion,
 * pacientes, facultativos, proveedores, ayuda, etc ...
 * 
 * 
 */
using System;
using System.Drawing;
using System.Windows.Forms;

using System.Drawing.Printing;
using MySql.Data.MySqlClient;
using System.Data;


namespace FormulacionMagistral
{
	/// <summary>
	/// Formulario Principal
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Label lblMaterialLote;
		private System.Windows.Forms.Label lblPropiedades;
		private System.Windows.Forms.Label lblApellidosUser;
		private System.Windows.Forms.TextBox txtMaterialID;
		private System.Windows.Forms.Button btnSaveCrt;
		private System.Windows.Forms.TextBox txtMaterialCaducidad;
		private System.Windows.Forms.TextBox txtMaterialProveedor;
		private System.Windows.Forms.MenuItem menuPreferencias;
		private System.Windows.Forms.Button btnMaterialAceptaciones;
		private System.Windows.Forms.TextBox txtMetodo;
		private System.Windows.Forms.Label lblContraindicaciones;
		private System.Windows.Forms.PictureBox pctLogo;
		private System.Windows.Forms.Button btnMaterialGuardar;
		private System.Windows.Forms.Button btnSinNuevo;
		private System.Windows.Forms.Label lblPasta;
		private System.Windows.Forms.TextBox txtMaterialCantidad;
		private System.Windows.Forms.Button btnMaterialPrev;
		private System.Windows.Forms.Label lblPrecio;
		private System.Windows.Forms.Button btnMaterialImpListado;
		private System.Windows.Forms.TabControl tabMain;
		private System.Windows.Forms.TextBox txtNombreUser;
		private System.Windows.Forms.MenuItem menuHerramientas;
		private System.Windows.Forms.Label lblPosMaterial;
		private System.Windows.Forms.TextBox txtDefincion;
		private System.Windows.Forms.TextBox txtMaterialProducto;
		private System.Windows.Forms.Label lblMaterialCaducidad;
		private System.Windows.Forms.ListBox lstEny;
		private System.Windows.Forms.Button btnMaterialBorrar;
		private System.Windows.Forms.MenuItem menuAbout;
		private System.Windows.Forms.Label lblIndicaciones;
		private System.Windows.Forms.TextBox txtMaterialLote;
		private System.Windows.Forms.TextBox txtCaracteres;
		private System.Windows.Forms.Label lblNombreUser;
		private System.Windows.Forms.TextBox txtDOE;
		private System.Windows.Forms.Button btnMaterialProveedor;
		private System.Windows.Forms.MenuItem menuGMaterias;
		private System.Windows.Forms.ListBox lstSinonimos;
		private System.Windows.Forms.MenuItem menuGMAcondi;
		private System.Windows.Forms.TextBox txtIndicaciones;
		private System.Windows.Forms.TabPage tabControles;
		private System.Windows.Forms.Button btnEliminarUser;
		private System.Windows.Forms.MenuItem menuVisorAlertas;
		private System.Windows.Forms.TextBox txtMaterialConservacion;
		private System.Windows.Forms.Button btnBorrarControl;
		private System.Windows.Forms.Button btnMaterialNext;
		private System.Windows.Forms.TextBox txtContraindicaciones;
		private System.Windows.Forms.Label lblCaracteres;
		private System.Windows.Forms.TextBox txtidUser;
		private System.Windows.Forms.MenuItem menuConfig;
		private System.Windows.Forms.TabPage tabMaterias;
		private System.Windows.Forms.TextBox txtConservacion;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuSubGRegistro;
		private System.Windows.Forms.TextBox txtRegistroID;
		private System.Windows.Forms.Button btnNuevoControl;
		private System.Windows.Forms.Label lblMaterialCantidad;
		private System.Windows.Forms.Button btnBorrarEny;
		private System.Windows.Forms.Label lblMetodo;
		private System.Windows.Forms.Button btnMaterialImprimir;
		private System.Windows.Forms.Label lblUsername;
		private System.Windows.Forms.MenuItem menuSubGProcs;
		private System.Windows.Forms.TabPage tabMaterial;
		private System.Windows.Forms.PictureBox pctAvatar;
		private System.Windows.Forms.Button btnMaterialFirst;
		private System.Windows.Forms.MenuItem menuAyuda;
		private System.Windows.Forms.MenuItem menuAssist;
		private System.Windows.Forms.TextBox txtMaterialNEnvases;
		private System.Windows.Forms.Label lblTipoUser;
		private System.Windows.Forms.MenuItem menuGFormulas;
		private System.Windows.Forms.MenuItem menuSubGEspecificacion;
		private System.Windows.Forms.Button btnImprimirControl;
		private System.Windows.Forms.Label lblMaterialProveedor;
		private System.Windows.Forms.Button btnNuevoEny;
		private System.Windows.Forms.MenuItem menuEnvases;
		private System.Windows.Forms.TextBox txtPrecio;
		private System.Windows.Forms.Label lblDefinicion;
		private System.Windows.Forms.TextBox txtUserName;
		private System.Windows.Forms.Button btnPrevCtr;
		private System.Windows.Forms.Label lblObservaciones;
		private System.Windows.Forms.MenuItem menuEtiquetas;
		private System.Windows.Forms.TextBox txtApellidosUser;
		private System.Windows.Forms.Label lblMaterialConservacion;
		private System.Windows.Forms.Button btnNextCrt;
		private System.Windows.Forms.Label lblMaterialNombre;
		private System.Windows.Forms.MenuItem menuGCalidad;
		private System.Windows.Forms.Button btnMaterialLast;
		private System.Windows.Forms.ListBox lstMaterias;
		private System.Windows.Forms.MenuItem menuSalir;
		private System.Windows.Forms.Label lblRegistroID;
		private System.Windows.Forms.MenuItem menuGPaciente;
		private System.Windows.Forms.Label lblMateriaID;
		private System.Windows.Forms.GroupBox grpUserInfo;
		private System.Windows.Forms.Label lblSinonimos;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Button btnFirstCrt;
		private System.Windows.Forms.Label lblResultados;
		private System.Windows.Forms.Label lblTipoUsuario2;
		private System.Windows.Forms.TextBox txtMaterialFechaRecepcion;
		private System.Windows.Forms.TextBox txtResultados;
		private System.Windows.Forms.TextBox txtPropiedades;
		private System.Windows.Forms.GroupBox grpUserManagement;
		private System.Windows.Forms.MenuItem menuGestion;
		private System.Windows.Forms.Button btnMaterialNuevo;
		private System.Windows.Forms.Label lblidUser;
		private System.Windows.Forms.Button btnUserNew;
		private System.Windows.Forms.Label lblControlID;
		private System.Windows.Forms.Label lblEnsayos;
		private System.Windows.Forms.Label lblPos;
		private System.Windows.Forms.TextBox txtControlID;
		private System.Windows.Forms.Button btnGuardarEny;
		private System.Windows.Forms.TextBox txtTipoUser;
		private System.Windows.Forms.Button btnSinEliminar;
		private System.Windows.Forms.ListBox lstUsersDisplay;
		private System.Windows.Forms.TextBox txtObservaciones;
		private System.Windows.Forms.Label lblConservacion;
		private System.Windows.Forms.MenuItem menuSubGAcepta;
		private System.Windows.Forms.MenuItem menuGProveedor;
		private System.Windows.Forms.TextBox txtUnidades;
		private System.Windows.Forms.Label lblMaterialEnvases;
		private System.Windows.Forms.Label lblMaterialID;
		private System.Windows.Forms.TextBox txtMateriaID;
		private System.Windows.Forms.ComboBox cmbTipoUser;
		private System.Windows.Forms.MenuItem menuGFacultativo;
		private System.Windows.Forms.Button btnLastCtr;
		private System.Windows.Forms.Label lblUnidades;
		private System.Windows.Forms.Label lblMaterialFecha;
		private System.Windows.Forms.Button btnUserSave;
		private System.Windows.Forms.Label lblDOE;
		private System.Windows.Forms.TabPage tabPersonal;
		private System.Windows.Forms.MenuItem menuGPersonal;
		private System.Windows.Forms.MenuItem menuAcciones;
		private System.Windows.Forms.Label lblAvataruser;
		private System.Windows.Forms.MenuItem menuTasar;
		private System.Windows.Forms.Button btnVerRegistro;
		
		
		
		
		
		
		#region Variables de la Base de datos y sus objetos de gestion
		private string dbhost; // IP o nombre a utilizar en la conexion con la BD
		private string dbport; // Puerto a utilizar en la conexion con la BD
		private string dbuser; // Usuario a utilizar en la conexion con la BD
		private string dbpasoteword; // Contrasea a utilizar en la conexion con la BD
		
		// Objeto de gestion de preferencias de la BD
		private Formulacion.PreferenciasDB DBPrefs; 
		
		#endregion
		

		
		#region Autorizacion, Alertas y Preferencias de Gestion.
		// Objeto de gestion de autorizacion de usuarios
		private Formulacion.FarmaAuthorize SecLocal;
		private Alertas AlertaLocal; // Alertas
		private Formulacion.PreferenciasGestion GstPrefs;
		
		private string Provincia; // Provincia a configurar
		private string Annus; // Ao para tasacion

		private string currentuser; // Nombre del usuario actual
		private int currentlevel;   // Nivel de autorizacion del usuario actual
		
		private int currentid;  // ID de la instancia de aplicacion actual
								// registrada en la tabla de la BD
		#endregion


		#region Objetos de la base de datos (Adapters, Connection, DataSets)
		private MySqlParameter parm;
		
		// Para control de calidad
		private MySqlDataAdapter adapControles;  // adap para los controles
		private MySqlDataAdapter adapEnsayos;    // adap para ensayos
		private DataSet dsCalidad;               // ds general para calidad
		private MySqlConnection conCalidad;      // conexion para calidad

		// Algunas variables para emular el CurrencyManager defectuoso de Mono
		private int ControlesRecCount;
		private int ControlesRecPosition;
		private int EnsayosRecCount;
		private int EnsayosRecPosition;

		
		// Para Material de acondicionamiento
		
		private MySqlDataAdapter adapMaterial;  // adap para el Material de acondicionamiento
		private DataSet dsMaterial;               // ds Material
		private MySqlConnection conMaterial;	// conexion para Material
		
		private int MaterialRecCount;
		private int MaterialRecPosition;
		
		#endregion
		
		#region Contructores
		
		/// <summary>
		/// Constructor de inicio del formulario
		/// </summary>
		/// <param name="appid">ID de la instancia actual</param> 
		public MainForm(int appid)
		{
			
			InitializeComponent();
			
			
			// Establece el ID de la instancia de la aplicacion
			this.currentid = appid;
			
			// Inicializa objetos de Preferencias, autorizacion y alertas
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			SecLocal = new Formulacion.FarmaAuthorize();
			AlertaLocal = new Alertas();
			GstPrefs = new Formulacion.PreferenciasGestion();
			GstPrefs.AsignarNmbFichero("PrefGestion.xml");

		}
		
		#endregion
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			this.btnVerRegistro = new System.Windows.Forms.Button();
			this.menuTasar = new System.Windows.Forms.MenuItem();
			this.lblAvataruser = new System.Windows.Forms.Label();
			this.menuAcciones = new System.Windows.Forms.MenuItem();
			this.menuGPersonal = new System.Windows.Forms.MenuItem();
			this.tabPersonal = new System.Windows.Forms.TabPage();
			this.lblDOE = new System.Windows.Forms.Label();
			this.btnUserSave = new System.Windows.Forms.Button();
			this.lblMaterialFecha = new System.Windows.Forms.Label();
			this.lblUnidades = new System.Windows.Forms.Label();
			this.btnLastCtr = new System.Windows.Forms.Button();
			this.menuGFacultativo = new System.Windows.Forms.MenuItem();
			this.cmbTipoUser = new System.Windows.Forms.ComboBox();
			this.txtMateriaID = new System.Windows.Forms.TextBox();
			this.lblMaterialID = new System.Windows.Forms.Label();
			this.lblMaterialEnvases = new System.Windows.Forms.Label();
			this.txtUnidades = new System.Windows.Forms.TextBox();
			this.menuGProveedor = new System.Windows.Forms.MenuItem();
			this.menuSubGAcepta = new System.Windows.Forms.MenuItem();
			this.lblConservacion = new System.Windows.Forms.Label();
			this.txtObservaciones = new System.Windows.Forms.TextBox();
			this.lstUsersDisplay = new System.Windows.Forms.ListBox();
			this.btnSinEliminar = new System.Windows.Forms.Button();
			this.txtTipoUser = new System.Windows.Forms.TextBox();
			this.btnGuardarEny = new System.Windows.Forms.Button();
			this.txtControlID = new System.Windows.Forms.TextBox();
			this.lblPos = new System.Windows.Forms.Label();
			this.lblEnsayos = new System.Windows.Forms.Label();
			this.lblControlID = new System.Windows.Forms.Label();
			this.btnUserNew = new System.Windows.Forms.Button();
			this.lblidUser = new System.Windows.Forms.Label();
			this.btnMaterialNuevo = new System.Windows.Forms.Button();
			this.menuGestion = new System.Windows.Forms.MenuItem();
			this.grpUserManagement = new System.Windows.Forms.GroupBox();
			this.txtPropiedades = new System.Windows.Forms.TextBox();
			this.txtResultados = new System.Windows.Forms.TextBox();
			this.txtMaterialFechaRecepcion = new System.Windows.Forms.TextBox();
			this.lblTipoUsuario2 = new System.Windows.Forms.Label();
			this.lblResultados = new System.Windows.Forms.Label();
			this.btnFirstCrt = new System.Windows.Forms.Button();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.lblSinonimos = new System.Windows.Forms.Label();
			this.grpUserInfo = new System.Windows.Forms.GroupBox();
			this.lblMateriaID = new System.Windows.Forms.Label();
			this.menuGPaciente = new System.Windows.Forms.MenuItem();
			this.lblRegistroID = new System.Windows.Forms.Label();
			this.menuSalir = new System.Windows.Forms.MenuItem();
			this.lstMaterias = new System.Windows.Forms.ListBox();
			this.btnMaterialLast = new System.Windows.Forms.Button();
			this.menuGCalidad = new System.Windows.Forms.MenuItem();
			this.lblMaterialNombre = new System.Windows.Forms.Label();
			this.btnNextCrt = new System.Windows.Forms.Button();
			this.lblMaterialConservacion = new System.Windows.Forms.Label();
			this.txtApellidosUser = new System.Windows.Forms.TextBox();
			this.menuEtiquetas = new System.Windows.Forms.MenuItem();
			this.lblObservaciones = new System.Windows.Forms.Label();
			this.btnPrevCtr = new System.Windows.Forms.Button();
			this.txtUserName = new System.Windows.Forms.TextBox();
			this.lblDefinicion = new System.Windows.Forms.Label();
			this.txtPrecio = new System.Windows.Forms.TextBox();
			this.menuEnvases = new System.Windows.Forms.MenuItem();
			this.btnNuevoEny = new System.Windows.Forms.Button();
			this.lblMaterialProveedor = new System.Windows.Forms.Label();
			this.btnImprimirControl = new System.Windows.Forms.Button();
			this.menuSubGEspecificacion = new System.Windows.Forms.MenuItem();
			this.menuGFormulas = new System.Windows.Forms.MenuItem();
			this.lblTipoUser = new System.Windows.Forms.Label();
			this.txtMaterialNEnvases = new System.Windows.Forms.TextBox();
			this.menuAssist = new System.Windows.Forms.MenuItem();
			this.menuAyuda = new System.Windows.Forms.MenuItem();
			this.btnMaterialFirst = new System.Windows.Forms.Button();
			this.pctAvatar = new System.Windows.Forms.PictureBox();
			this.tabMaterial = new System.Windows.Forms.TabPage();
			this.menuSubGProcs = new System.Windows.Forms.MenuItem();
			this.lblUsername = new System.Windows.Forms.Label();
			this.btnMaterialImprimir = new System.Windows.Forms.Button();
			this.lblMetodo = new System.Windows.Forms.Label();
			this.btnBorrarEny = new System.Windows.Forms.Button();
			this.lblMaterialCantidad = new System.Windows.Forms.Label();
			this.btnNuevoControl = new System.Windows.Forms.Button();
			this.txtRegistroID = new System.Windows.Forms.TextBox();
			this.menuSubGRegistro = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.txtConservacion = new System.Windows.Forms.TextBox();
			this.tabMaterias = new System.Windows.Forms.TabPage();
			this.menuConfig = new System.Windows.Forms.MenuItem();
			this.txtidUser = new System.Windows.Forms.TextBox();
			this.lblCaracteres = new System.Windows.Forms.Label();
			this.txtContraindicaciones = new System.Windows.Forms.TextBox();
			this.btnMaterialNext = new System.Windows.Forms.Button();
			this.btnBorrarControl = new System.Windows.Forms.Button();
			this.txtMaterialConservacion = new System.Windows.Forms.TextBox();
			this.menuVisorAlertas = new System.Windows.Forms.MenuItem();
			this.btnEliminarUser = new System.Windows.Forms.Button();
			this.tabControles = new System.Windows.Forms.TabPage();
			this.txtIndicaciones = new System.Windows.Forms.TextBox();
			this.menuGMAcondi = new System.Windows.Forms.MenuItem();
			this.lstSinonimos = new System.Windows.Forms.ListBox();
			this.menuGMaterias = new System.Windows.Forms.MenuItem();
			this.btnMaterialProveedor = new System.Windows.Forms.Button();
			this.txtDOE = new System.Windows.Forms.TextBox();
			this.lblNombreUser = new System.Windows.Forms.Label();
			this.txtCaracteres = new System.Windows.Forms.TextBox();
			this.txtMaterialLote = new System.Windows.Forms.TextBox();
			this.lblIndicaciones = new System.Windows.Forms.Label();
			this.menuAbout = new System.Windows.Forms.MenuItem();
			this.btnMaterialBorrar = new System.Windows.Forms.Button();
			this.lstEny = new System.Windows.Forms.ListBox();
			this.lblMaterialCaducidad = new System.Windows.Forms.Label();
			this.txtMaterialProducto = new System.Windows.Forms.TextBox();
			this.txtDefincion = new System.Windows.Forms.TextBox();
			this.lblPosMaterial = new System.Windows.Forms.Label();
			this.menuHerramientas = new System.Windows.Forms.MenuItem();
			this.txtNombreUser = new System.Windows.Forms.TextBox();
			this.tabMain = new System.Windows.Forms.TabControl();
			this.btnMaterialImpListado = new System.Windows.Forms.Button();
			this.lblPrecio = new System.Windows.Forms.Label();
			this.btnMaterialPrev = new System.Windows.Forms.Button();
			this.txtMaterialCantidad = new System.Windows.Forms.TextBox();
			this.lblPasta = new System.Windows.Forms.Label();
			this.btnSinNuevo = new System.Windows.Forms.Button();
			this.btnMaterialGuardar = new System.Windows.Forms.Button();
			this.pctLogo = new System.Windows.Forms.PictureBox();
			this.lblContraindicaciones = new System.Windows.Forms.Label();
			this.txtMetodo = new System.Windows.Forms.TextBox();
			this.btnMaterialAceptaciones = new System.Windows.Forms.Button();
			this.menuPreferencias = new System.Windows.Forms.MenuItem();
			this.txtMaterialProveedor = new System.Windows.Forms.TextBox();
			this.txtMaterialCaducidad = new System.Windows.Forms.TextBox();
			this.btnSaveCrt = new System.Windows.Forms.Button();
			this.txtMaterialID = new System.Windows.Forms.TextBox();
			this.lblApellidosUser = new System.Windows.Forms.Label();
			this.lblPropiedades = new System.Windows.Forms.Label();
			this.lblMaterialLote = new System.Windows.Forms.Label();
			this.tabPersonal.SuspendLayout();
			this.grpUserManagement.SuspendLayout();
			this.grpUserInfo.SuspendLayout();
			this.tabMaterial.SuspendLayout();
			this.tabMaterias.SuspendLayout();
			this.tabControles.SuspendLayout();
			this.tabMain.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnVerRegistro
			// 
			this.btnVerRegistro.Location = new System.Drawing.Point(584, 32);
			this.btnVerRegistro.Name = "btnVerRegistro";
			this.btnVerRegistro.Size = new System.Drawing.Size(112, 24);
			this.btnVerRegistro.TabIndex = 23;
			this.btnVerRegistro.Text = "Ver Registro";
			// 
			// menuTasar
			// 
			this.menuTasar.Index = 0;
			this.menuTasar.Text = "Tasar";
			this.menuTasar.Click += new System.EventHandler(this.MenuTasarClick);
			// 
			// lblAvataruser
			// 
			this.lblAvataruser.Location = new System.Drawing.Point(696, 48);
			this.lblAvataruser.Name = "lblAvataruser";
			this.lblAvataruser.Size = new System.Drawing.Size(176, 24);
			this.lblAvataruser.TabIndex = 6;
			this.lblAvataruser.Text = "Logo";
			// 
			// menuAcciones
			// 
			this.menuAcciones.Index = 0;
			this.menuAcciones.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuTasar,
						this.menuSalir});
			this.menuAcciones.Text = "Acciones";
			// 
			// menuGPersonal
			// 
			this.menuGPersonal.Index = 6;
			this.menuGPersonal.Text = "Personal";
			this.menuGPersonal.Click += new System.EventHandler(this.MenuGPersonalClick);
			// 
			// tabPersonal
			// 
			this.tabPersonal.BackColor = System.Drawing.Color.Gray;
			this.tabPersonal.Controls.Add(this.grpUserManagement);
			this.tabPersonal.Controls.Add(this.grpUserInfo);
			this.tabPersonal.ImageIndex = 2;
			this.tabPersonal.Location = new System.Drawing.Point(4, 28);
			this.tabPersonal.Name = "tabPersonal";
			this.tabPersonal.Size = new System.Drawing.Size(1000, 632);
			this.tabPersonal.TabIndex = 3;
			this.tabPersonal.Text = "Personal";
			// 
			// lblDOE
			// 
			this.lblDOE.Location = new System.Drawing.Point(416, 32);
			this.lblDOE.Name = "lblDOE";
			this.lblDOE.Size = new System.Drawing.Size(128, 16);
			this.lblDOE.TabIndex = 2;
			this.lblDOE.Text = "D.O.E";
			// 
			// btnUserSave
			// 
			this.btnUserSave.Location = new System.Drawing.Point(200, 376);
			this.btnUserSave.Name = "btnUserSave";
			this.btnUserSave.Size = new System.Drawing.Size(152, 32);
			this.btnUserSave.TabIndex = 16;
			this.btnUserSave.Text = "Modificar";
			this.btnUserSave.Click += new System.EventHandler(this.BtnUserSaveClick);
			// 
			// lblMaterialFecha
			// 
			this.lblMaterialFecha.Location = new System.Drawing.Point(560, 224);
			this.lblMaterialFecha.Name = "lblMaterialFecha";
			this.lblMaterialFecha.Size = new System.Drawing.Size(192, 24);
			this.lblMaterialFecha.TabIndex = 5;
			this.lblMaterialFecha.Text = "Fecha Recepcin";
			// 
			// lblUnidades
			// 
			this.lblUnidades.Location = new System.Drawing.Point(592, 576);
			this.lblUnidades.Name = "lblUnidades";
			this.lblUnidades.Size = new System.Drawing.Size(80, 24);
			this.lblUnidades.TabIndex = 9;
			this.lblUnidades.Text = "Unidades";
			// 
			// btnLastCtr
			// 
			this.btnLastCtr.Location = new System.Drawing.Point(248, 64);
			this.btnLastCtr.Name = "btnLastCtr";
			this.btnLastCtr.Size = new System.Drawing.Size(40, 24);
			this.btnLastCtr.TabIndex = 29;
			this.btnLastCtr.Text = "->|";
			this.btnLastCtr.Click += new System.EventHandler(this.BtnLastCtrClick);
			// 
			// menuGFacultativo
			// 
			this.menuGFacultativo.Index = 3;
			this.menuGFacultativo.Text = "Facultativos";
			this.menuGFacultativo.Click += new System.EventHandler(this.MenuGFacultativoClick);
			// 
			// cmbTipoUser
			// 
			this.cmbTipoUser.Location = new System.Drawing.Point(408, 200);
			this.cmbTipoUser.Name = "cmbTipoUser";
			this.cmbTipoUser.Size = new System.Drawing.Size(240, 27);
			this.cmbTipoUser.TabIndex = 20;
			// 
			// txtMateriaID
			// 
			this.txtMateriaID.Enabled = false;
			this.txtMateriaID.Location = new System.Drawing.Point(320, 24);
			this.txtMateriaID.Name = "txtMateriaID";
			this.txtMateriaID.Size = new System.Drawing.Size(72, 27);
			this.txtMateriaID.TabIndex = 11;
			this.txtMateriaID.Text = "";
			// 
			// lblMaterialID
			// 
			this.lblMaterialID.Location = new System.Drawing.Point(16, 40);
			this.lblMaterialID.Name = "lblMaterialID";
			this.lblMaterialID.Size = new System.Drawing.Size(88, 24);
			this.lblMaterialID.TabIndex = 1;
			this.lblMaterialID.Text = "ID";
			// 
			// lblMaterialEnvases
			// 
			this.lblMaterialEnvases.Location = new System.Drawing.Point(560, 128);
			this.lblMaterialEnvases.Name = "lblMaterialEnvases";
			this.lblMaterialEnvases.Size = new System.Drawing.Size(200, 24);
			this.lblMaterialEnvases.TabIndex = 7;
			this.lblMaterialEnvases.Text = "Numero envases";
			// 
			// txtUnidades
			// 
			this.txtUnidades.Enabled = false;
			this.txtUnidades.Location = new System.Drawing.Point(680, 576);
			this.txtUnidades.Name = "txtUnidades";
			this.txtUnidades.Size = new System.Drawing.Size(168, 27);
			this.txtUnidades.TabIndex = 20;
			this.txtUnidades.Text = "";
			// 
			// menuGProveedor
			// 
			this.menuGProveedor.Index = 2;
			this.menuGProveedor.Text = "Proveedores";
			this.menuGProveedor.Click += new System.EventHandler(this.MenuGProveedorClick);
			// 
			// menuSubGAcepta
			// 
			this.menuSubGAcepta.Index = 3;
			this.menuSubGAcepta.Text = "Aceptaciones";
			// 
			// lblConservacion
			// 
			this.lblConservacion.Location = new System.Drawing.Point(256, 400);
			this.lblConservacion.Name = "lblConservacion";
			this.lblConservacion.Size = new System.Drawing.Size(168, 16);
			this.lblConservacion.TabIndex = 8;
			this.lblConservacion.Text = "Conservacion";
			// 
			// txtObservaciones
			// 
			this.txtObservaciones.AcceptsReturn = true;
			this.txtObservaciones.AcceptsTab = true;
			this.txtObservaciones.Location = new System.Drawing.Point(600, 424);
			this.txtObservaciones.Multiline = true;
			this.txtObservaciones.Name = "txtObservaciones";
			this.txtObservaciones.ReadOnly = true;
			this.txtObservaciones.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtObservaciones.Size = new System.Drawing.Size(376, 96);
			this.txtObservaciones.TabIndex = 19;
			this.txtObservaciones.Text = "";
			// 
			// lstUsersDisplay
			// 
			this.lstUsersDisplay.ItemHeight = 19;
			this.lstUsersDisplay.Location = new System.Drawing.Point(32, 48);
			this.lstUsersDisplay.Name = "lstUsersDisplay";
			this.lstUsersDisplay.Size = new System.Drawing.Size(152, 270);
			this.lstUsersDisplay.TabIndex = 1;
			this.lstUsersDisplay.SelectedIndexChanged += new System.EventHandler(this.lstUserDisplay_SelectedIndex);
			// 
			// btnSinEliminar
			// 
			this.btnSinEliminar.Location = new System.Drawing.Point(408, 144);
			this.btnSinEliminar.Name = "btnSinEliminar";
			this.btnSinEliminar.Size = new System.Drawing.Size(88, 24);
			this.btnSinEliminar.TabIndex = 25;
			this.btnSinEliminar.Text = "Eliminar";
			// 
			// txtTipoUser
			// 
			this.txtTipoUser.Enabled = false;
			this.txtTipoUser.Location = new System.Drawing.Point(560, 32);
			this.txtTipoUser.Name = "txtTipoUser";
			this.txtTipoUser.Size = new System.Drawing.Size(144, 27);
			this.txtTipoUser.TabIndex = 3;
			this.txtTipoUser.Text = "";
			// 
			// btnGuardarEny
			// 
			this.btnGuardarEny.Location = new System.Drawing.Point(24, 344);
			this.btnGuardarEny.Name = "btnGuardarEny";
			this.btnGuardarEny.Size = new System.Drawing.Size(136, 24);
			this.btnGuardarEny.TabIndex = 20;
			this.btnGuardarEny.Text = "Guardar Ensayo";
			this.btnGuardarEny.Click += new System.EventHandler(this.BtnGuardarEnyClick);
			// 
			// txtControlID
			// 
			this.txtControlID.Enabled = false;
			this.txtControlID.Location = new System.Drawing.Point(144, 32);
			this.txtControlID.Name = "txtControlID";
			this.txtControlID.Size = new System.Drawing.Size(136, 27);
			this.txtControlID.TabIndex = 1;
			this.txtControlID.Text = "";
			// 
			// lblPos
			// 
			this.lblPos.Location = new System.Drawing.Point(104, 64);
			this.lblPos.Name = "lblPos";
			this.lblPos.Size = new System.Drawing.Size(96, 24);
			this.lblPos.TabIndex = 12;
			this.lblPos.Text = "0 de 0";
			this.lblPos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblEnsayos
			// 
			this.lblEnsayos.Location = new System.Drawing.Point(24, 136);
			this.lblEnsayos.Name = "lblEnsayos";
			this.lblEnsayos.Size = new System.Drawing.Size(136, 24);
			this.lblEnsayos.TabIndex = 3;
			this.lblEnsayos.Text = "Ensayo:";
			// 
			// lblControlID
			// 
			this.lblControlID.Location = new System.Drawing.Point(24, 32);
			this.lblControlID.Name = "lblControlID";
			this.lblControlID.Size = new System.Drawing.Size(112, 24);
			this.lblControlID.TabIndex = 0;
			this.lblControlID.Text = "Control ID";
			// 
			// btnUserNew
			// 
			this.btnUserNew.Location = new System.Drawing.Point(48, 376);
			this.btnUserNew.Name = "btnUserNew";
			this.btnUserNew.Size = new System.Drawing.Size(128, 32);
			this.btnUserNew.TabIndex = 0;
			this.btnUserNew.Text = "Nuevo Usuario";
			this.btnUserNew.Click += new System.EventHandler(this.BtnUserNewClick);
			// 
			// lblidUser
			// 
			this.lblidUser.Location = new System.Drawing.Point(232, 152);
			this.lblidUser.Name = "lblidUser";
			this.lblidUser.Size = new System.Drawing.Size(176, 24);
			this.lblidUser.TabIndex = 4;
			this.lblidUser.Text = "Nombre de Usuario:";
			// 
			// btnMaterialNuevo
			// 
			this.btnMaterialNuevo.Location = new System.Drawing.Point(32, 288);
			this.btnMaterialNuevo.Name = "btnMaterialNuevo";
			this.btnMaterialNuevo.Size = new System.Drawing.Size(136, 24);
			this.btnMaterialNuevo.TabIndex = 29;
			this.btnMaterialNuevo.Text = "Nuevo";
			this.btnMaterialNuevo.Click += new System.EventHandler(this.BtnMaterialNuevoClick);
			// 
			// menuGestion
			// 
			this.menuGestion.Index = 1;
			this.menuGestion.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuGFormulas,
						this.menuGMaterias,
						this.menuGProveedor,
						this.menuGFacultativo,
						this.menuGPaciente,
						this.menuGMAcondi,
						this.menuGPersonal,
						this.menuGCalidad,
						this.menuEnvases});
			this.menuGestion.Text = "Gestin";
			// 
			// grpUserManagement
			// 
			this.grpUserManagement.Controls.Add(this.cmbTipoUser);
			this.grpUserManagement.Controls.Add(this.lblTipoUsuario2);
			this.grpUserManagement.Controls.Add(this.btnEliminarUser);
			this.grpUserManagement.Controls.Add(this.btnUserSave);
			this.grpUserManagement.Controls.Add(this.pctLogo);
			this.grpUserManagement.Controls.Add(this.txtidUser);
			this.grpUserManagement.Controls.Add(this.txtApellidosUser);
			this.grpUserManagement.Controls.Add(this.txtNombreUser);
			this.grpUserManagement.Controls.Add(this.lblAvataruser);
			this.grpUserManagement.Controls.Add(this.lblidUser);
			this.grpUserManagement.Controls.Add(this.lblApellidosUser);
			this.grpUserManagement.Controls.Add(this.lblNombreUser);
			this.grpUserManagement.Controls.Add(this.lstUsersDisplay);
			this.grpUserManagement.Controls.Add(this.btnUserNew);
			this.grpUserManagement.Location = new System.Drawing.Point(32, 152);
			this.grpUserManagement.Name = "grpUserManagement";
			this.grpUserManagement.Size = new System.Drawing.Size(928, 424);
			this.grpUserManagement.TabIndex = 1;
			this.grpUserManagement.TabStop = false;
			this.grpUserManagement.Text = "Gestin de usuarios";
			// 
			// txtPropiedades
			// 
			this.txtPropiedades.AcceptsReturn = true;
			this.txtPropiedades.AcceptsTab = true;
			this.txtPropiedades.Location = new System.Drawing.Point(256, 320);
			this.txtPropiedades.Multiline = true;
			this.txtPropiedades.Name = "txtPropiedades";
			this.txtPropiedades.ReadOnly = true;
			this.txtPropiedades.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtPropiedades.Size = new System.Drawing.Size(296, 72);
			this.txtPropiedades.TabIndex = 16;
			this.txtPropiedades.Text = "";
			// 
			// txtResultados
			// 
			this.txtResultados.AcceptsReturn = true;
			this.txtResultados.AcceptsTab = true;
			this.txtResultados.Location = new System.Drawing.Point(192, 400);
			this.txtResultados.Multiline = true;
			this.txtResultados.Name = "txtResultados";
			this.txtResultados.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtResultados.Size = new System.Drawing.Size(792, 208);
			this.txtResultados.TabIndex = 6;
			this.txtResultados.Text = "";
			// 
			// txtMaterialFechaRecepcion
			// 
			this.txtMaterialFechaRecepcion.Location = new System.Drawing.Point(768, 224);
			this.txtMaterialFechaRecepcion.Name = "txtMaterialFechaRecepcion";
			this.txtMaterialFechaRecepcion.Size = new System.Drawing.Size(160, 27);
			this.txtMaterialFechaRecepcion.TabIndex = 20;
			this.txtMaterialFechaRecepcion.Text = "";
			// 
			// lblTipoUsuario2
			// 
			this.lblTipoUsuario2.Location = new System.Drawing.Point(232, 200);
			this.lblTipoUsuario2.Name = "lblTipoUsuario2";
			this.lblTipoUsuario2.Size = new System.Drawing.Size(144, 24);
			this.lblTipoUsuario2.TabIndex = 19;
			this.lblTipoUsuario2.Text = "Tipo Usuario:";
			// 
			// lblResultados
			// 
			this.lblResultados.Location = new System.Drawing.Point(192, 376);
			this.lblResultados.Name = "lblResultados";
			this.lblResultados.Size = new System.Drawing.Size(184, 16);
			this.lblResultados.TabIndex = 7;
			this.lblResultados.Text = "Resultados";
			// 
			// btnFirstCrt
			// 
			this.btnFirstCrt.Location = new System.Drawing.Point(24, 64);
			this.btnFirstCrt.Name = "btnFirstCrt";
			this.btnFirstCrt.Size = new System.Drawing.Size(40, 24);
			this.btnFirstCrt.TabIndex = 25;
			this.btnFirstCrt.Text = "|<-";
			this.btnFirstCrt.Click += new System.EventHandler(this.BtnFirstCrtClick);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// lblSinonimos
			// 
			this.lblSinonimos.Location = new System.Drawing.Point(264, 64);
			this.lblSinonimos.Name = "lblSinonimos";
			this.lblSinonimos.Size = new System.Drawing.Size(168, 24);
			this.lblSinonimos.TabIndex = 23;
			this.lblSinonimos.Text = "Sinonimos";
			// 
			// grpUserInfo
			// 
			this.grpUserInfo.Controls.Add(this.pctAvatar);
			this.grpUserInfo.Controls.Add(this.txtTipoUser);
			this.grpUserInfo.Controls.Add(this.lblTipoUser);
			this.grpUserInfo.Controls.Add(this.txtUserName);
			this.grpUserInfo.Controls.Add(this.lblUsername);
			this.grpUserInfo.Location = new System.Drawing.Point(24, 24);
			this.grpUserInfo.Name = "grpUserInfo";
			this.grpUserInfo.Size = new System.Drawing.Size(936, 112);
			this.grpUserInfo.TabIndex = 0;
			this.grpUserInfo.TabStop = false;
			this.grpUserInfo.Text = "Informacin Usuario Actual";
			// 
			// lblMateriaID
			// 
			this.lblMateriaID.Location = new System.Drawing.Point(256, 32);
			this.lblMateriaID.Name = "lblMateriaID";
			this.lblMateriaID.Size = new System.Drawing.Size(56, 16);
			this.lblMateriaID.TabIndex = 1;
			this.lblMateriaID.Text = "ID";
			// 
			// menuGPaciente
			// 
			this.menuGPaciente.Index = 4;
			this.menuGPaciente.Text = "Pacientes";
			this.menuGPaciente.Click += new System.EventHandler(this.MenuGPacienteClick);
			// 
			// lblRegistroID
			// 
			this.lblRegistroID.Location = new System.Drawing.Point(304, 32);
			this.lblRegistroID.Name = "lblRegistroID";
			this.lblRegistroID.Size = new System.Drawing.Size(152, 24);
			this.lblRegistroID.TabIndex = 21;
			this.lblRegistroID.Text = "Registro Materia ID";
			// 
			// menuSalir
			// 
			this.menuSalir.Index = 1;
			this.menuSalir.Text = "Salir";
			this.menuSalir.Click += new System.EventHandler(this.MenuSalirClick);
			// 
			// lstMaterias
			// 
			this.lstMaterias.ItemHeight = 19;
			this.lstMaterias.Location = new System.Drawing.Point(8, 24);
			this.lstMaterias.Name = "lstMaterias";
			this.lstMaterias.Size = new System.Drawing.Size(240, 574);
			this.lstMaterias.TabIndex = 0;
			this.lstMaterias.SelectedIndexChanged += new System.EventHandler(this.LstMateriasSelectedIndexChanged);
			// 
			// btnMaterialLast
			// 
			this.btnMaterialLast.Location = new System.Drawing.Point(224, 8);
			this.btnMaterialLast.Name = "btnMaterialLast";
			this.btnMaterialLast.Size = new System.Drawing.Size(40, 24);
			this.btnMaterialLast.TabIndex = 24;
			this.btnMaterialLast.Text = "->|";
			this.btnMaterialLast.Click += new System.EventHandler(this.BtnMaterialLastClick);
			// 
			// menuGCalidad
			// 
			this.menuGCalidad.Index = 7;
			this.menuGCalidad.Text = "Gestin de Calidad";
			this.menuGCalidad.Click += new System.EventHandler(this.MenuGCalidadClick);
			// 
			// lblMaterialNombre
			// 
			this.lblMaterialNombre.Location = new System.Drawing.Point(224, 40);
			this.lblMaterialNombre.Name = "lblMaterialNombre";
			this.lblMaterialNombre.Size = new System.Drawing.Size(80, 24);
			this.lblMaterialNombre.TabIndex = 2;
			this.lblMaterialNombre.Text = "Producto";
			// 
			// btnNextCrt
			// 
			this.btnNextCrt.Location = new System.Drawing.Point(208, 64);
			this.btnNextCrt.Name = "btnNextCrt";
			this.btnNextCrt.Size = new System.Drawing.Size(40, 24);
			this.btnNextCrt.TabIndex = 28;
			this.btnNextCrt.Text = "->";
			this.btnNextCrt.Click += new System.EventHandler(this.BtnNextCrtClick);
			// 
			// lblMaterialConservacion
			// 
			this.lblMaterialConservacion.Location = new System.Drawing.Point(216, 272);
			this.lblMaterialConservacion.Name = "lblMaterialConservacion";
			this.lblMaterialConservacion.Size = new System.Drawing.Size(200, 24);
			this.lblMaterialConservacion.TabIndex = 9;
			this.lblMaterialConservacion.Text = "Condiciones Conservacin";
			// 
			// txtApellidosUser
			// 
			this.txtApellidosUser.Location = new System.Drawing.Point(408, 88);
			this.txtApellidosUser.Name = "txtApellidosUser";
			this.txtApellidosUser.Size = new System.Drawing.Size(240, 27);
			this.txtApellidosUser.TabIndex = 9;
			this.txtApellidosUser.Text = "";
			// 
			// menuEtiquetas
			// 
			this.menuEtiquetas.Index = 0;
			this.menuEtiquetas.Text = "Etiquetas";
			this.menuEtiquetas.Click += new System.EventHandler(this.MenuEtiquetasClick);
			// 
			// lblObservaciones
			// 
			this.lblObservaciones.Location = new System.Drawing.Point(600, 400);
			this.lblObservaciones.Name = "lblObservaciones";
			this.lblObservaciones.Size = new System.Drawing.Size(152, 16);
			this.lblObservaciones.TabIndex = 10;
			this.lblObservaciones.Text = "Observaciones";
			// 
			// btnPrevCtr
			// 
			this.btnPrevCtr.Location = new System.Drawing.Point(64, 64);
			this.btnPrevCtr.Name = "btnPrevCtr";
			this.btnPrevCtr.Size = new System.Drawing.Size(40, 24);
			this.btnPrevCtr.TabIndex = 27;
			this.btnPrevCtr.Text = "<-";
			this.btnPrevCtr.Click += new System.EventHandler(this.BtnPrevCtrClick);
			// 
			// txtUserName
			// 
			this.txtUserName.Enabled = false;
			this.txtUserName.Location = new System.Drawing.Point(208, 32);
			this.txtUserName.Name = "txtUserName";
			this.txtUserName.Size = new System.Drawing.Size(144, 27);
			this.txtUserName.TabIndex = 1;
			this.txtUserName.Text = "";
			// 
			// lblDefinicion
			// 
			this.lblDefinicion.Location = new System.Drawing.Point(576, 64);
			this.lblDefinicion.Name = "lblDefinicion";
			this.lblDefinicion.Size = new System.Drawing.Size(128, 24);
			this.lblDefinicion.TabIndex = 3;
			this.lblDefinicion.Text = "Definicion";
			// 
			// txtPrecio
			// 
			this.txtPrecio.Enabled = false;
			this.txtPrecio.Location = new System.Drawing.Point(360, 576);
			this.txtPrecio.Name = "txtPrecio";
			this.txtPrecio.Size = new System.Drawing.Size(104, 27);
			this.txtPrecio.TabIndex = 27;
			this.txtPrecio.Text = "";
			// 
			// menuEnvases
			// 
			this.menuEnvases.Index = 8;
			this.menuEnvases.Text = "Envases";
			this.menuEnvases.Click += new System.EventHandler(this.MenuEnvasesClick);
			// 
			// btnNuevoEny
			// 
			this.btnNuevoEny.Location = new System.Drawing.Point(24, 312);
			this.btnNuevoEny.Name = "btnNuevoEny";
			this.btnNuevoEny.Size = new System.Drawing.Size(136, 24);
			this.btnNuevoEny.TabIndex = 19;
			this.btnNuevoEny.Text = "Nuevo Ensayo";
			this.btnNuevoEny.Click += new System.EventHandler(this.BtnNuevoEnyClick);
			// 
			// lblMaterialProveedor
			// 
			this.lblMaterialProveedor.Location = new System.Drawing.Point(32, 104);
			this.lblMaterialProveedor.Name = "lblMaterialProveedor";
			this.lblMaterialProveedor.Size = new System.Drawing.Size(80, 24);
			this.lblMaterialProveedor.TabIndex = 3;
			this.lblMaterialProveedor.Text = "Proveedor";
			// 
			// btnImprimirControl
			// 
			this.btnImprimirControl.Location = new System.Drawing.Point(752, 40);
			this.btnImprimirControl.Name = "btnImprimirControl";
			this.btnImprimirControl.Size = new System.Drawing.Size(200, 24);
			this.btnImprimirControl.TabIndex = 17;
			this.btnImprimirControl.Text = "Imprimir Informe Control";
			// 
			// menuSubGEspecificacion
			// 
			this.menuSubGEspecificacion.Index = 2;
			this.menuSubGEspecificacion.Text = "Especificaciones";
			this.menuSubGEspecificacion.Click += new System.EventHandler(this.MenuSubGEspecificacionClick);
			// 
			// menuGFormulas
			// 
			this.menuGFormulas.Index = 0;
			this.menuGFormulas.Text = "Formulas";
			this.menuGFormulas.Click += new System.EventHandler(this.MenuGFormulasClick);
			// 
			// lblTipoUser
			// 
			this.lblTipoUser.Location = new System.Drawing.Point(376, 32);
			this.lblTipoUser.Name = "lblTipoUser";
			this.lblTipoUser.Size = new System.Drawing.Size(160, 24);
			this.lblTipoUser.TabIndex = 2;
			this.lblTipoUser.Text = "Tipo de Usuario:";
			// 
			// txtMaterialNEnvases
			// 
			this.txtMaterialNEnvases.Location = new System.Drawing.Point(768, 128);
			this.txtMaterialNEnvases.Name = "txtMaterialNEnvases";
			this.txtMaterialNEnvases.Size = new System.Drawing.Size(160, 27);
			this.txtMaterialNEnvases.TabIndex = 15;
			this.txtMaterialNEnvases.Text = "";
			// 
			// menuAssist
			// 
			this.menuAssist.Checked = true;
			this.menuAssist.Index = 0;
			this.menuAssist.Text = "Asistente";
			this.menuAssist.Click += new System.EventHandler(this.MenuAssistClick);
			// 
			// menuAyuda
			// 
			this.menuAyuda.Index = 3;
			this.menuAyuda.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuAssist,
						this.menuAbout});
			this.menuAyuda.Text = "Ayuda";
			// 
			// btnMaterialFirst
			// 
			this.btnMaterialFirst.Location = new System.Drawing.Point(16, 8);
			this.btnMaterialFirst.Name = "btnMaterialFirst";
			this.btnMaterialFirst.Size = new System.Drawing.Size(40, 24);
			this.btnMaterialFirst.TabIndex = 21;
			this.btnMaterialFirst.Text = "|<-";
			this.btnMaterialFirst.Click += new System.EventHandler(this.BtnMaterialFirstClick);
			// 
			// pctAvatar
			// 
			this.pctAvatar.Location = new System.Drawing.Point(776, 32);
			this.pctAvatar.Name = "pctAvatar";
			this.pctAvatar.Size = new System.Drawing.Size(112, 64);
			this.pctAvatar.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.pctAvatar.TabIndex = 4;
			this.pctAvatar.TabStop = false;
			// 
			// tabMaterial
			// 
			this.tabMaterial.Controls.Add(this.btnMaterialImpListado);
			this.tabMaterial.Controls.Add(this.btnMaterialNuevo);
			this.tabMaterial.Controls.Add(this.btnMaterialImprimir);
			this.tabMaterial.Controls.Add(this.btnMaterialGuardar);
			this.tabMaterial.Controls.Add(this.btnMaterialBorrar);
			this.tabMaterial.Controls.Add(this.lblPosMaterial);
			this.tabMaterial.Controls.Add(this.btnMaterialLast);
			this.tabMaterial.Controls.Add(this.btnMaterialNext);
			this.tabMaterial.Controls.Add(this.btnMaterialPrev);
			this.tabMaterial.Controls.Add(this.btnMaterialFirst);
			this.tabMaterial.Controls.Add(this.txtMaterialFechaRecepcion);
			this.tabMaterial.Controls.Add(this.btnMaterialAceptaciones);
			this.tabMaterial.Controls.Add(this.txtMaterialProveedor);
			this.tabMaterial.Controls.Add(this.txtMaterialConservacion);
			this.tabMaterial.Controls.Add(this.txtMaterialCaducidad);
			this.tabMaterial.Controls.Add(this.txtMaterialNEnvases);
			this.tabMaterial.Controls.Add(this.txtMaterialCantidad);
			this.tabMaterial.Controls.Add(this.btnMaterialProveedor);
			this.tabMaterial.Controls.Add(this.txtMaterialLote);
			this.tabMaterial.Controls.Add(this.txtMaterialProducto);
			this.tabMaterial.Controls.Add(this.lblMaterialConservacion);
			this.tabMaterial.Controls.Add(this.lblMaterialCaducidad);
			this.tabMaterial.Controls.Add(this.lblMaterialEnvases);
			this.tabMaterial.Controls.Add(this.lblMaterialCantidad);
			this.tabMaterial.Controls.Add(this.lblMaterialFecha);
			this.tabMaterial.Controls.Add(this.lblMaterialLote);
			this.tabMaterial.Controls.Add(this.lblMaterialProveedor);
			this.tabMaterial.Controls.Add(this.lblMaterialNombre);
			this.tabMaterial.Controls.Add(this.lblMaterialID);
			this.tabMaterial.Controls.Add(this.txtMaterialID);
			this.tabMaterial.ImageIndex = 1;
			this.tabMaterial.Location = new System.Drawing.Point(4, 28);
			this.tabMaterial.Name = "tabMaterial";
			this.tabMaterial.Size = new System.Drawing.Size(1000, 632);
			this.tabMaterial.TabIndex = 1;
			this.tabMaterial.Text = "Material Acondicionamiento";
			this.tabMaterial.Click += new System.EventHandler(this.TabMaterialClick);
			// 
			// menuSubGProcs
			// 
			this.menuSubGProcs.Index = 1;
			this.menuSubGProcs.Text = "Procedimientos";
			// 
			// lblUsername
			// 
			this.lblUsername.Location = new System.Drawing.Point(24, 32);
			this.lblUsername.Name = "lblUsername";
			this.lblUsername.Size = new System.Drawing.Size(160, 24);
			this.lblUsername.TabIndex = 0;
			this.lblUsername.Text = "Nombre de Usuario:";
			// 
			// btnMaterialImprimir
			// 
			this.btnMaterialImprimir.Location = new System.Drawing.Point(32, 408);
			this.btnMaterialImprimir.Name = "btnMaterialImprimir";
			this.btnMaterialImprimir.Size = new System.Drawing.Size(136, 24);
			this.btnMaterialImprimir.TabIndex = 28;
			this.btnMaterialImprimir.Text = "Imprimir";
			this.btnMaterialImprimir.Click += new System.EventHandler(this.BtnMaterialImprimirClick);
			// 
			// lblMetodo
			// 
			this.lblMetodo.Location = new System.Drawing.Point(192, 136);
			this.lblMetodo.Name = "lblMetodo";
			this.lblMetodo.Size = new System.Drawing.Size(128, 24);
			this.lblMetodo.TabIndex = 4;
			this.lblMetodo.Text = "Mtodo";
			// 
			// btnBorrarEny
			// 
			this.btnBorrarEny.Location = new System.Drawing.Point(24, 280);
			this.btnBorrarEny.Name = "btnBorrarEny";
			this.btnBorrarEny.Size = new System.Drawing.Size(136, 24);
			this.btnBorrarEny.TabIndex = 18;
			this.btnBorrarEny.Text = "Borrar Ensayo";
			this.btnBorrarEny.Click += new System.EventHandler(this.BtnBorrarEnyClick);
			// 
			// lblMaterialCantidad
			// 
			this.lblMaterialCantidad.Location = new System.Drawing.Point(560, 80);
			this.lblMaterialCantidad.Name = "lblMaterialCantidad";
			this.lblMaterialCantidad.Size = new System.Drawing.Size(200, 16);
			this.lblMaterialCantidad.TabIndex = 6;
			this.lblMaterialCantidad.Text = "Cantidad";
			// 
			// btnNuevoControl
			// 
			this.btnNuevoControl.Location = new System.Drawing.Point(752, 8);
			this.btnNuevoControl.Name = "btnNuevoControl";
			this.btnNuevoControl.Size = new System.Drawing.Size(200, 24);
			this.btnNuevoControl.TabIndex = 15;
			this.btnNuevoControl.Text = "Nuevo Control";
			this.btnNuevoControl.Click += new System.EventHandler(this.BtnNuevoControlClick);
			// 
			// txtRegistroID
			// 
			this.txtRegistroID.Enabled = false;
			this.txtRegistroID.Location = new System.Drawing.Point(456, 32);
			this.txtRegistroID.Name = "txtRegistroID";
			this.txtRegistroID.Size = new System.Drawing.Size(104, 27);
			this.txtRegistroID.TabIndex = 22;
			this.txtRegistroID.Text = "";
			// 
			// menuSubGRegistro
			// 
			this.menuSubGRegistro.Index = 0;
			this.menuSubGRegistro.Text = "Registro";
			this.menuSubGRegistro.Click += new System.EventHandler(this.MenuSubGRegistroClick);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuAcciones,
						this.menuGestion,
						this.menuHerramientas,
						this.menuAyuda});
			// 
			// txtConservacion
			// 
			this.txtConservacion.AcceptsReturn = true;
			this.txtConservacion.AcceptsTab = true;
			this.txtConservacion.Location = new System.Drawing.Point(256, 424);
			this.txtConservacion.Multiline = true;
			this.txtConservacion.Name = "txtConservacion";
			this.txtConservacion.ReadOnly = true;
			this.txtConservacion.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtConservacion.Size = new System.Drawing.Size(304, 136);
			this.txtConservacion.TabIndex = 18;
			this.txtConservacion.Text = "";
			// 
			// tabMaterias
			// 
			this.tabMaterias.BackColor = System.Drawing.Color.Silver;
			this.tabMaterias.Controls.Add(this.lblPasta);
			this.tabMaterias.Controls.Add(this.txtPrecio);
			this.tabMaterias.Controls.Add(this.lblPrecio);
			this.tabMaterias.Controls.Add(this.btnSinEliminar);
			this.tabMaterias.Controls.Add(this.btnSinNuevo);
			this.tabMaterias.Controls.Add(this.lblSinonimos);
			this.tabMaterias.Controls.Add(this.lstSinonimos);
			this.tabMaterias.Controls.Add(this.txtUnidades);
			this.tabMaterias.Controls.Add(this.txtObservaciones);
			this.tabMaterias.Controls.Add(this.txtConservacion);
			this.tabMaterias.Controls.Add(this.txtContraindicaciones);
			this.tabMaterias.Controls.Add(this.txtPropiedades);
			this.tabMaterias.Controls.Add(this.txtIndicaciones);
			this.tabMaterias.Controls.Add(this.txtCaracteres);
			this.tabMaterias.Controls.Add(this.txtDefincion);
			this.tabMaterias.Controls.Add(this.txtDOE);
			this.tabMaterias.Controls.Add(this.txtMateriaID);
			this.tabMaterias.Controls.Add(this.lblObservaciones);
			this.tabMaterias.Controls.Add(this.lblUnidades);
			this.tabMaterias.Controls.Add(this.lblConservacion);
			this.tabMaterias.Controls.Add(this.lblContraindicaciones);
			this.tabMaterias.Controls.Add(this.lblPropiedades);
			this.tabMaterias.Controls.Add(this.lblIndicaciones);
			this.tabMaterias.Controls.Add(this.lblCaracteres);
			this.tabMaterias.Controls.Add(this.lblDefinicion);
			this.tabMaterias.Controls.Add(this.lblDOE);
			this.tabMaterias.Controls.Add(this.lblMateriaID);
			this.tabMaterias.Controls.Add(this.lstMaterias);
			this.tabMaterias.ImageIndex = 1;
			this.tabMaterias.Location = new System.Drawing.Point(4, 28);
			this.tabMaterias.Name = "tabMaterias";
			this.tabMaterias.Size = new System.Drawing.Size(1000, 632);
			this.tabMaterias.TabIndex = 0;
			this.tabMaterias.Text = "Materias primas";
			// 
			// menuConfig
			// 
			this.menuConfig.Index = 2;
			this.menuConfig.Text = "Configuracin";
			this.menuConfig.Click += new System.EventHandler(this.menuConfig_Click);
			// 
			// txtidUser
			// 
			this.txtidUser.Location = new System.Drawing.Point(408, 144);
			this.txtidUser.Name = "txtidUser";
			this.txtidUser.Size = new System.Drawing.Size(240, 27);
			this.txtidUser.TabIndex = 10;
			this.txtidUser.Text = "";
			// 
			// lblCaracteres
			// 
			this.lblCaracteres.Location = new System.Drawing.Point(264, 184);
			this.lblCaracteres.Name = "lblCaracteres";
			this.lblCaracteres.Size = new System.Drawing.Size(128, 16);
			this.lblCaracteres.TabIndex = 4;
			this.lblCaracteres.Text = "Caracteres";
			// 
			// txtContraindicaciones
			// 
			this.txtContraindicaciones.AcceptsReturn = true;
			this.txtContraindicaciones.AcceptsTab = true;
			this.txtContraindicaciones.Location = new System.Drawing.Point(600, 320);
			this.txtContraindicaciones.Multiline = true;
			this.txtContraindicaciones.Name = "txtContraindicaciones";
			this.txtContraindicaciones.ReadOnly = true;
			this.txtContraindicaciones.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtContraindicaciones.Size = new System.Drawing.Size(376, 72);
			this.txtContraindicaciones.TabIndex = 17;
			this.txtContraindicaciones.Text = "";
			// 
			// btnMaterialNext
			// 
			this.btnMaterialNext.Location = new System.Drawing.Point(184, 8);
			this.btnMaterialNext.Name = "btnMaterialNext";
			this.btnMaterialNext.Size = new System.Drawing.Size(40, 24);
			this.btnMaterialNext.TabIndex = 23;
			this.btnMaterialNext.Text = "->";
			this.btnMaterialNext.Click += new System.EventHandler(this.BtnMaterialNextClick);
			// 
			// btnBorrarControl
			// 
			this.btnBorrarControl.Location = new System.Drawing.Point(752, 72);
			this.btnBorrarControl.Name = "btnBorrarControl";
			this.btnBorrarControl.Size = new System.Drawing.Size(200, 24);
			this.btnBorrarControl.TabIndex = 16;
			this.btnBorrarControl.Text = "Borrar Control";
			this.btnBorrarControl.Click += new System.EventHandler(this.BtnBorrarControlClick);
			// 
			// txtMaterialConservacion
			// 
			this.txtMaterialConservacion.Location = new System.Drawing.Point(216, 296);
			this.txtMaterialConservacion.Multiline = true;
			this.txtMaterialConservacion.Name = "txtMaterialConservacion";
			this.txtMaterialConservacion.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtMaterialConservacion.Size = new System.Drawing.Size(752, 296);
			this.txtMaterialConservacion.TabIndex = 17;
			this.txtMaterialConservacion.Text = "";
			// 
			// menuVisorAlertas
			// 
			this.menuVisorAlertas.Index = 3;
			this.menuVisorAlertas.Text = "Visor de Alertas";
			this.menuVisorAlertas.Click += new System.EventHandler(this.MenuVisorAlertasClick);
			// 
			// btnEliminarUser
			// 
			this.btnEliminarUser.Location = new System.Drawing.Point(376, 376);
			this.btnEliminarUser.Name = "btnEliminarUser";
			this.btnEliminarUser.Size = new System.Drawing.Size(112, 32);
			this.btnEliminarUser.TabIndex = 17;
			this.btnEliminarUser.Text = "Eliminar";
			this.btnEliminarUser.Click += new System.EventHandler(this.BtnEliminarUserClick);
			// 
			// tabControles
			// 
			this.tabControles.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.tabControles.Controls.Add(this.btnSaveCrt);
			this.tabControles.Controls.Add(this.lstEny);
			this.tabControles.Controls.Add(this.btnLastCtr);
			this.tabControles.Controls.Add(this.btnNextCrt);
			this.tabControles.Controls.Add(this.btnPrevCtr);
			this.tabControles.Controls.Add(this.btnFirstCrt);
			this.tabControles.Controls.Add(this.btnVerRegistro);
			this.tabControles.Controls.Add(this.txtRegistroID);
			this.tabControles.Controls.Add(this.lblRegistroID);
			this.tabControles.Controls.Add(this.btnGuardarEny);
			this.tabControles.Controls.Add(this.btnNuevoEny);
			this.tabControles.Controls.Add(this.btnBorrarEny);
			this.tabControles.Controls.Add(this.btnImprimirControl);
			this.tabControles.Controls.Add(this.btnBorrarControl);
			this.tabControles.Controls.Add(this.btnNuevoControl);
			this.tabControles.Controls.Add(this.lblPos);
			this.tabControles.Controls.Add(this.lblResultados);
			this.tabControles.Controls.Add(this.txtResultados);
			this.tabControles.Controls.Add(this.txtMetodo);
			this.tabControles.Controls.Add(this.lblMetodo);
			this.tabControles.Controls.Add(this.lblEnsayos);
			this.tabControles.Controls.Add(this.txtControlID);
			this.tabControles.Controls.Add(this.lblControlID);
			this.tabControles.ImageIndex = 3;
			this.tabControles.Location = new System.Drawing.Point(4, 28);
			this.tabControles.Name = "tabControles";
			this.tabControles.Size = new System.Drawing.Size(1000, 632);
			this.tabControles.TabIndex = 2;
			this.tabControles.Text = "Control Calidad";
			// 
			// txtIndicaciones
			// 
			this.txtIndicaciones.AcceptsReturn = true;
			this.txtIndicaciones.AcceptsTab = true;
			this.txtIndicaciones.Location = new System.Drawing.Point(592, 208);
			this.txtIndicaciones.Multiline = true;
			this.txtIndicaciones.Name = "txtIndicaciones";
			this.txtIndicaciones.ReadOnly = true;
			this.txtIndicaciones.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtIndicaciones.Size = new System.Drawing.Size(376, 80);
			this.txtIndicaciones.TabIndex = 15;
			this.txtIndicaciones.Text = "";
			// 
			// menuGMAcondi
			// 
			this.menuGMAcondi.Index = 5;
			this.menuGMAcondi.Text = "Material Acondicionamiento";
			this.menuGMAcondi.Click += new System.EventHandler(this.MenuGMAcondiClick);
			// 
			// lstSinonimos
			// 
			this.lstSinonimos.ItemHeight = 19;
			this.lstSinonimos.Location = new System.Drawing.Point(264, 96);
			this.lstSinonimos.Name = "lstSinonimos";
			this.lstSinonimos.Size = new System.Drawing.Size(288, 42);
			this.lstSinonimos.TabIndex = 22;
			// 
			// menuGMaterias
			// 
			this.menuGMaterias.Index = 1;
			this.menuGMaterias.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuSubGRegistro,
						this.menuSubGProcs,
						this.menuSubGEspecificacion,
						this.menuSubGAcepta});
			this.menuGMaterias.Text = "Materias Primas";
			// 
			// btnMaterialProveedor
			// 
			this.btnMaterialProveedor.Location = new System.Drawing.Point(328, 104);
			this.btnMaterialProveedor.Name = "btnMaterialProveedor";
			this.btnMaterialProveedor.Size = new System.Drawing.Size(184, 24);
			this.btnMaterialProveedor.TabIndex = 13;
			this.btnMaterialProveedor.Text = "Ver Detalles Proveedor";
			this.btnMaterialProveedor.Click += new System.EventHandler(this.BtnMaterialProveedorClick);
			// 
			// txtDOE
			// 
			this.txtDOE.Enabled = false;
			this.txtDOE.Location = new System.Drawing.Point(560, 24);
			this.txtDOE.Name = "txtDOE";
			this.txtDOE.Size = new System.Drawing.Size(408, 27);
			this.txtDOE.TabIndex = 12;
			this.txtDOE.Text = "";
			// 
			// lblNombreUser
			// 
			this.lblNombreUser.Location = new System.Drawing.Point(232, 56);
			this.lblNombreUser.Name = "lblNombreUser";
			this.lblNombreUser.Size = new System.Drawing.Size(104, 16);
			this.lblNombreUser.TabIndex = 2;
			this.lblNombreUser.Text = "Nombre:";
			// 
			// txtCaracteres
			// 
			this.txtCaracteres.AcceptsReturn = true;
			this.txtCaracteres.AcceptsTab = true;
			this.txtCaracteres.Location = new System.Drawing.Point(256, 208);
			this.txtCaracteres.Multiline = true;
			this.txtCaracteres.Name = "txtCaracteres";
			this.txtCaracteres.ReadOnly = true;
			this.txtCaracteres.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtCaracteres.Size = new System.Drawing.Size(304, 80);
			this.txtCaracteres.TabIndex = 14;
			this.txtCaracteres.Text = "";
			// 
			// txtMaterialLote
			// 
			this.txtMaterialLote.Location = new System.Drawing.Point(136, 160);
			this.txtMaterialLote.Name = "txtMaterialLote";
			this.txtMaterialLote.Size = new System.Drawing.Size(176, 27);
			this.txtMaterialLote.TabIndex = 12;
			this.txtMaterialLote.Text = "";
			// 
			// lblIndicaciones
			// 
			this.lblIndicaciones.Location = new System.Drawing.Point(592, 176);
			this.lblIndicaciones.Name = "lblIndicaciones";
			this.lblIndicaciones.Size = new System.Drawing.Size(120, 24);
			this.lblIndicaciones.TabIndex = 5;
			this.lblIndicaciones.Text = "Indicaciones";
			// 
			// menuAbout
			// 
			this.menuAbout.Index = 1;
			this.menuAbout.Text = "Acerca de";
			this.menuAbout.Click += new System.EventHandler(this.MenuAboutClick);
			// 
			// btnMaterialBorrar
			// 
			this.btnMaterialBorrar.Location = new System.Drawing.Point(32, 328);
			this.btnMaterialBorrar.Name = "btnMaterialBorrar";
			this.btnMaterialBorrar.Size = new System.Drawing.Size(136, 24);
			this.btnMaterialBorrar.TabIndex = 26;
			this.btnMaterialBorrar.Text = "Borrar";
			this.btnMaterialBorrar.Click += new System.EventHandler(this.BtnMaterialBorrarClick);
			// 
			// lstEny
			// 
			this.lstEny.ItemHeight = 19;
			this.lstEny.Location = new System.Drawing.Point(24, 168);
			this.lstEny.Name = "lstEny";
			this.lstEny.Size = new System.Drawing.Size(136, 99);
			this.lstEny.TabIndex = 30;
			// 
			// lblMaterialCaducidad
			// 
			this.lblMaterialCaducidad.Location = new System.Drawing.Point(560, 176);
			this.lblMaterialCaducidad.Name = "lblMaterialCaducidad";
			this.lblMaterialCaducidad.Size = new System.Drawing.Size(200, 24);
			this.lblMaterialCaducidad.TabIndex = 8;
			this.lblMaterialCaducidad.Text = "Fecha de caducidad";
			// 
			// txtMaterialProducto
			// 
			this.txtMaterialProducto.Location = new System.Drawing.Point(320, 40);
			this.txtMaterialProducto.Name = "txtMaterialProducto";
			this.txtMaterialProducto.Size = new System.Drawing.Size(608, 27);
			this.txtMaterialProducto.TabIndex = 11;
			this.txtMaterialProducto.Text = "";
			// 
			// txtDefincion
			// 
			this.txtDefincion.AcceptsReturn = true;
			this.txtDefincion.AcceptsTab = true;
			this.txtDefincion.Location = new System.Drawing.Point(576, 96);
			this.txtDefincion.Multiline = true;
			this.txtDefincion.Name = "txtDefincion";
			this.txtDefincion.ReadOnly = true;
			this.txtDefincion.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtDefincion.Size = new System.Drawing.Size(400, 56);
			this.txtDefincion.TabIndex = 13;
			this.txtDefincion.Text = "";
			// 
			// lblPosMaterial
			// 
			this.lblPosMaterial.Location = new System.Drawing.Point(104, 8);
			this.lblPosMaterial.Name = "lblPosMaterial";
			this.lblPosMaterial.Size = new System.Drawing.Size(72, 24);
			this.lblPosMaterial.TabIndex = 25;
			this.lblPosMaterial.Text = "0 de 0";
			this.lblPosMaterial.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// menuHerramientas
			// 
			this.menuHerramientas.Index = 2;
			this.menuHerramientas.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.menuEtiquetas,
						this.menuPreferencias,
						this.menuConfig,
						this.menuVisorAlertas});
			this.menuHerramientas.Text = "Herramientas";
			// 
			// txtNombreUser
			// 
			this.txtNombreUser.Location = new System.Drawing.Point(408, 48);
			this.txtNombreUser.Name = "txtNombreUser";
			this.txtNombreUser.Size = new System.Drawing.Size(240, 27);
			this.txtNombreUser.TabIndex = 8;
			this.txtNombreUser.Text = "";
			// 
			// tabMain
			// 
			this.tabMain.Controls.Add(this.tabMaterias);
			this.tabMain.Controls.Add(this.tabControles);
			this.tabMain.Controls.Add(this.tabMaterial);
			this.tabMain.Controls.Add(this.tabPersonal);
			this.tabMain.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tabMain.ImageList = this.imageList1;
			this.tabMain.Location = new System.Drawing.Point(8, 24);
			this.tabMain.Multiline = true;
			this.tabMain.Name = "tabMain";
			this.tabMain.SelectedIndex = 0;
			this.tabMain.Size = new System.Drawing.Size(1008, 664);
			this.tabMain.TabIndex = 0;
			this.tabMain.Click += new System.EventHandler(this.TabMainClick);
			// 
			// btnMaterialImpListado
			// 
			this.btnMaterialImpListado.Location = new System.Drawing.Point(32, 448);
			this.btnMaterialImpListado.Name = "btnMaterialImpListado";
			this.btnMaterialImpListado.Size = new System.Drawing.Size(136, 24);
			this.btnMaterialImpListado.TabIndex = 30;
			this.btnMaterialImpListado.Text = "Imprimir Listado";
			this.btnMaterialImpListado.Click += new System.EventHandler(this.BtnMaterialImpListadoClick);
			// 
			// lblPrecio
			// 
			this.lblPrecio.Location = new System.Drawing.Point(264, 576);
			this.lblPrecio.Name = "lblPrecio";
			this.lblPrecio.Size = new System.Drawing.Size(96, 24);
			this.lblPrecio.TabIndex = 26;
			this.lblPrecio.Text = "Precio";
			// 
			// btnMaterialPrev
			// 
			this.btnMaterialPrev.Location = new System.Drawing.Point(56, 8);
			this.btnMaterialPrev.Name = "btnMaterialPrev";
			this.btnMaterialPrev.Size = new System.Drawing.Size(40, 24);
			this.btnMaterialPrev.TabIndex = 22;
			this.btnMaterialPrev.Text = "<-";
			this.btnMaterialPrev.Click += new System.EventHandler(this.BtnMaterialPrevClick);
			// 
			// txtMaterialCantidad
			// 
			this.txtMaterialCantidad.Location = new System.Drawing.Point(768, 80);
			this.txtMaterialCantidad.Name = "txtMaterialCantidad";
			this.txtMaterialCantidad.Size = new System.Drawing.Size(160, 27);
			this.txtMaterialCantidad.TabIndex = 14;
			this.txtMaterialCantidad.Text = "";
			// 
			// lblPasta
			// 
			this.lblPasta.Location = new System.Drawing.Point(472, 576);
			this.lblPasta.Name = "lblPasta";
			this.lblPasta.Size = new System.Drawing.Size(48, 24);
			this.lblPasta.TabIndex = 28;
			this.lblPasta.Text = "";
			// 
			// btnSinNuevo
			// 
			this.btnSinNuevo.Location = new System.Drawing.Point(304, 144);
			this.btnSinNuevo.Name = "btnSinNuevo";
			this.btnSinNuevo.Size = new System.Drawing.Size(72, 24);
			this.btnSinNuevo.TabIndex = 24;
			this.btnSinNuevo.Text = "Nuevo";
			this.btnSinNuevo.Click += new System.EventHandler(this.BtnSinNuevoClick);
			// 
			// btnMaterialGuardar
			// 
			this.btnMaterialGuardar.Location = new System.Drawing.Point(32, 368);
			this.btnMaterialGuardar.Name = "btnMaterialGuardar";
			this.btnMaterialGuardar.Size = new System.Drawing.Size(136, 24);
			this.btnMaterialGuardar.TabIndex = 27;
			this.btnMaterialGuardar.Text = "Guardar";
			this.btnMaterialGuardar.Click += new System.EventHandler(this.BtnMaterialGuardarClick);
			// 
			// pctLogo
			// 
			this.pctLogo.Location = new System.Drawing.Point(696, 88);
			this.pctLogo.Name = "pctLogo";
			this.pctLogo.Size = new System.Drawing.Size(200, 128);
			this.pctLogo.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pctLogo.TabIndex = 15;
			this.pctLogo.TabStop = false;
			// 
			// lblContraindicaciones
			// 
			this.lblContraindicaciones.Location = new System.Drawing.Point(600, 296);
			this.lblContraindicaciones.Name = "lblContraindicaciones";
			this.lblContraindicaciones.Size = new System.Drawing.Size(152, 24);
			this.lblContraindicaciones.TabIndex = 7;
			this.lblContraindicaciones.Text = "Contraindicaciones";
			// 
			// txtMetodo
			// 
			this.txtMetodo.AcceptsReturn = true;
			this.txtMetodo.AcceptsTab = true;
			this.txtMetodo.Location = new System.Drawing.Point(192, 168);
			this.txtMetodo.Multiline = true;
			this.txtMetodo.Name = "txtMetodo";
			this.txtMetodo.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtMetodo.Size = new System.Drawing.Size(792, 208);
			this.txtMetodo.TabIndex = 5;
			this.txtMetodo.Text = "";
			// 
			// btnMaterialAceptaciones
			// 
			this.btnMaterialAceptaciones.Location = new System.Drawing.Point(32, 496);
			this.btnMaterialAceptaciones.Name = "btnMaterialAceptaciones";
			this.btnMaterialAceptaciones.Size = new System.Drawing.Size(136, 48);
			this.btnMaterialAceptaciones.TabIndex = 19;
			this.btnMaterialAceptaciones.Text = "Aceptaciones Asociadas";
			this.btnMaterialAceptaciones.Click += new System.EventHandler(this.BtnMaterialAceptacionesClick);
			// 
			// menuPreferencias
			// 
			this.menuPreferencias.Index = 1;
			this.menuPreferencias.Text = "Preferencias";
			// 
			// txtMaterialProveedor
			// 
			this.txtMaterialProveedor.Location = new System.Drawing.Point(136, 104);
			this.txtMaterialProveedor.Name = "txtMaterialProveedor";
			this.txtMaterialProveedor.Size = new System.Drawing.Size(176, 27);
			this.txtMaterialProveedor.TabIndex = 18;
			this.txtMaterialProveedor.Text = "";
			// 
			// txtMaterialCaducidad
			// 
			this.txtMaterialCaducidad.Location = new System.Drawing.Point(768, 176);
			this.txtMaterialCaducidad.Name = "txtMaterialCaducidad";
			this.txtMaterialCaducidad.Size = new System.Drawing.Size(160, 27);
			this.txtMaterialCaducidad.TabIndex = 16;
			this.txtMaterialCaducidad.Text = "";
			// 
			// btnSaveCrt
			// 
			this.btnSaveCrt.Location = new System.Drawing.Point(752, 104);
			this.btnSaveCrt.Name = "btnSaveCrt";
			this.btnSaveCrt.Size = new System.Drawing.Size(200, 24);
			this.btnSaveCrt.TabIndex = 31;
			this.btnSaveCrt.Text = "Guardar Control";
			this.btnSaveCrt.Click += new System.EventHandler(this.BtnSaveCrtClick);
			// 
			// txtMaterialID
			// 
			this.txtMaterialID.Location = new System.Drawing.Point(112, 40);
			this.txtMaterialID.Name = "txtMaterialID";
			this.txtMaterialID.Size = new System.Drawing.Size(80, 27);
			this.txtMaterialID.TabIndex = 0;
			this.txtMaterialID.Text = "";
			// 
			// lblApellidosUser
			// 
			this.lblApellidosUser.Location = new System.Drawing.Point(232, 96);
			this.lblApellidosUser.Name = "lblApellidosUser";
			this.lblApellidosUser.Size = new System.Drawing.Size(104, 24);
			this.lblApellidosUser.TabIndex = 3;
			this.lblApellidosUser.Text = "Apellidos:";
			// 
			// lblPropiedades
			// 
			this.lblPropiedades.Location = new System.Drawing.Point(256, 296);
			this.lblPropiedades.Name = "lblPropiedades";
			this.lblPropiedades.Size = new System.Drawing.Size(104, 24);
			this.lblPropiedades.TabIndex = 6;
			this.lblPropiedades.Text = "Propiedades";
			// 
			// lblMaterialLote
			// 
			this.lblMaterialLote.Location = new System.Drawing.Point(32, 160);
			this.lblMaterialLote.Name = "lblMaterialLote";
			this.lblMaterialLote.Size = new System.Drawing.Size(80, 24);
			this.lblMaterialLote.TabIndex = 4;
			this.lblMaterialLote.Text = "Lote";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1028, 701);
			this.Controls.Add(this.tabMain);
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Formulacion Magistral ";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainFormClosing);
			this.Load += new System.EventHandler(this.MainFormLoad);
			this.tabPersonal.ResumeLayout(false);
			this.grpUserManagement.ResumeLayout(false);
			this.grpUserInfo.ResumeLayout(false);
			this.tabMaterial.ResumeLayout(false);
			this.tabMaterias.ResumeLayout(false);
			this.tabControles.ResumeLayout(false);
			this.tabMain.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion
		
		#region Metodos de control de datos de Control de calidad
		
		
		/// <summary>
		/// Carga datos iniciales de control de calidad
		/// </summary>
		bool CargarDatosControlCalidad(){
			
			try{
				conCalidad = new MySqlConnection("host="+this.dbhost+";port="+ this.dbport.ToString()+";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");
		 		dsCalidad = new System.Data.DataSet();
		 	
		 		adapControles = new MySqlDataAdapter();
		 		adapControles.SelectCommand = new MySqlCommand("SELECT * FROM controles;",conCalidad);
			 	adapControles.Fill(dsCalidad,"Controles");
		 	
			 	adapEnsayos = new MySqlDataAdapter();
			 	adapEnsayos.SelectCommand = new MySqlCommand("SELECT * FROM ensayos;",conCalidad);
		 		adapEnsayos.Fill(dsCalidad,"Ensayos");
		 	
			 	return true;
			}catch(MySqlException ex){
				FM_Errores.MostrarError("ControlCalidad:MainForm","Error relacionado con base de datos",ex);
				return false;
			}catch(Exception e){
				FM_Errores.MostrarError("ControlCalidad:MainForm","Error general. No se puede cargar la informacion de control de calidad",e);
				return false;
			}
			
		}
		
		/// <summary>
		/// Define la logica de actualizacion de los controles de calidad
		/// </summary>
		private void CargarComandoUpdateCalidad(){
			adapControles.UpdateCommand = new MySqlCommand("Update controles Set RegistroID = ?RegistroID WHERE ControlID = ?ControlID",conCalidad);
			
			parm = adapControles.UpdateCommand.Parameters.Add("?ControlID", MySqlDbType.Int32);
			parm.SourceColumn = "ControlID";
			parm.SourceVersion = DataRowVersion.Original;
			
			parm = adapControles.UpdateCommand.Parameters.Add("?RegistroID", MySqlDbType.Int32);
			parm.SourceColumn = "RegistroID";
			parm.SourceVersion = DataRowVersion.Original;
			
			// Parte de Ensayos
			
			adapEnsayos.UpdateCommand = new MySqlCommand("Update ensayos Set  Metodo = ?Metodo, Resultado = ?Resultado WHERE ControlID = ?ControlID",conCalidad);
			
			parm = adapEnsayos.UpdateCommand.Parameters.Add("?ControlID", MySqlDbType.Int32);
			parm.SourceColumn = "ControlID";
			parm.SourceVersion = DataRowVersion.Original;
							
			parm = adapEnsayos.UpdateCommand.Parameters.Add("?Metodo", MySqlDbType.VarChar, 500 );
			parm.SourceColumn = "Metodo";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adapEnsayos.UpdateCommand.Parameters.Add("?Resultado", MySqlDbType.VarChar, 500 );
			parm.SourceColumn = "Resultado";
			parm.SourceVersion = DataRowVersion.Current;

		}

		/// <summary>
		/// Define la logica de borrado de control de calidad
		/// </summary>
		private void CargarComandoDeleteCalidad(){
			adapControles.DeleteCommand = new MySqlCommand("DELETE FROM controles WHERE ControlID = ?ControlID",conCalidad);
			
			parm = adapControles.DeleteCommand.Parameters.Add("?ControlID", MySqlDbType.Int32);
			parm.SourceColumn = "ControlID";
			parm.SourceVersion = DataRowVersion.Original;
			
			
			adapEnsayos.DeleteCommand = new MySqlCommand("DELETE FROM ensayos WHERE EnsayoID = ?EnsayoID",conCalidad);
			
			parm = adapEnsayos.DeleteCommand.Parameters.Add("?EnsayoID", MySqlDbType.Int32);
			parm.SourceColumn = "EnsayoID";
			parm.SourceVersion = DataRowVersion.Original;
			
		}
		
		
		/// <summary>
		/// Define la logica de nuevos controles de calidad
		/// </summary>
		private void CargarComandoInsertCalidad(){
			adapControles.InsertCommand = new MySqlCommand("Insert into controles(ControlID, RegistroID) VALUES (?ControlID,?RegistroID)",conCalidad);
			
			parm = adapControles.InsertCommand.Parameters.Add("?ControlID", MySqlDbType.Int32);
			parm.SourceColumn = "ControlID";
			parm.SourceVersion = DataRowVersion.Original;
			
			parm = adapControles.InsertCommand.Parameters.Add("?RegistroID", MySqlDbType.Int32);
			parm.SourceColumn = "RegistroID";
			parm.SourceVersion = DataRowVersion.Current;
			
			
			// Parte de Ensayos
			
			adapEnsayos.InsertCommand = new MySqlCommand("Insert into ensayos (ControlID,Metodo,Resultado) VALUES (?ControlID, ?Metodo, ?Resultado)",conCalidad);
			
			parm = adapEnsayos.InsertCommand.Parameters.Add("?ControlID", MySqlDbType.Int32);
			parm.SourceColumn = "ControlID";
			parm.SourceVersion = DataRowVersion.Original;
							
			parm = adapEnsayos.InsertCommand.Parameters.Add("?Metodo", MySqlDbType.VarChar, 500 );
			parm.SourceColumn = "Metodo";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adapEnsayos.InsertCommand.Parameters.Add("?Resultado", MySqlDbType.VarChar, 500 );
			parm.SourceColumn = "Resultado";
			parm.SourceVersion = DataRowVersion.Current;

		}

		
		/// <summary>
		/// Muestra la posicion en el dataset de control de calidad
		/// </summary>
		void MostrarPosicionCalidad(){
			lblPos.Text = (this.ControlesRecPosition + 1) + 
                             " de " + this.ControlesRecCount;

		}
		

		/// <summary>
		/// Guarda modificaciones de Control de Calidad
		/// </summary>
		void GuardarModificaciones()
		{
			try
    			{
        		int ModificacionesControles, ModificacionesEnsayos;
					DataRow[] pendientes;
					DataViewRowState dvrs;
				
					dvrs = DataViewRowState.Added | DataViewRowState.ModifiedCurrent;
					pendientes = dsCalidad.Tables[0].Select("","",dvrs); // Tabla 0 es controles en el DataSet
					ModificacionesControles = adapControles.Update(pendientes);
					
					ModificacionesEnsayos = adapEnsayos.Update(dsCalidad,"Ensayos");
					
					dvrs = DataViewRowState.Deleted;
					pendientes = dsCalidad.Tables[0].Select("", "", dvrs);
					ModificacionesControles += adapControles.Update(pendientes);
					
					
					dsCalidad.Clear();
        			adapControles.Fill(dsCalidad,"Controles");
        			adapEnsayos.Fill(dsCalidad,"Ensayos");
        			FM_Errores.MostrarAviso("Actualizacion correcta","Actualizados "+ModificacionesControles+" controles y " + ModificacionesEnsayos + " ensayos");

        			
				}catch (Exception ex){
					FM_Errores.MostrarError("Actualizacion","Error actualizando datos",ex);
        	    }
		}

		
		
		#endregion
		

		#region Metodos de control de datos de Material de Acondicionamiento
		
		
		void CargarRegistroMaterial( int numero){
			if( numero >=0 && numero < dsMaterial.Tables[0].Rows.Count)
			{
				this.txtMaterialID.Text = dsMaterial.Tables[0].Rows[numero]["AcondicionamientoID"].ToString();
				this.txtMaterialProducto.Text = dsMaterial.Tables[0].Rows[numero]["Nombre"].ToString();
			    this.txtMaterialProveedor.Text = dsMaterial.Tables[0].Rows[numero]["ProveedorID"].ToString();
			    this.txtMaterialLote.Text = dsMaterial.Tables[0].Rows[numero]["Lote"].ToString();
			    this.txtMaterialFechaRecepcion.Text = dsMaterial.Tables[0].Rows[numero]["FechaRecepcion"].ToString();
			    this.txtMaterialCantidad.Text = dsMaterial.Tables[0].Rows[numero]["Cantidad"].ToString();
			    this.txtMaterialNEnvases.Text = dsMaterial.Tables[0].Rows[numero]["NEnvases"].ToString();
			    this.txtMaterialCaducidad.Text = dsMaterial.Tables[0].Rows[numero]["FechaCaducidad"].ToString();
			    this.txtMaterialConservacion.Text = dsMaterial.Tables[0].Rows[numero]["Conservacion"].ToString();
			    //TODO. Falta AceptacionID campo 9
			}
		}

		void GuardarRegistroMaterial(int numero){
			try{
			dsMaterial.Tables[0].Rows[numero].BeginEdit();
			dsMaterial.Tables[0].Rows[numero]["AcondicionamientoID"] = this.txtMaterialID.Text;
			dsMaterial.Tables[0].Rows[numero]["Nombre"] = this.txtMaterialProducto.Text;
			dsMaterial.Tables[0].Rows[numero]["ProveedorID"] = this.txtMaterialProveedor.Text;
			dsMaterial.Tables[0].Rows[numero]["Lote"] = this.txtMaterialLote.Text;
			dsMaterial.Tables[0].Rows[numero]["FechaRecepcion"] = this.txtMaterialFechaRecepcion.Text;
			dsMaterial.Tables[0].Rows[numero]["Cantidad"] = this.txtMaterialCantidad.Text;
			dsMaterial.Tables[0].Rows[numero]["NEnvases"] = this.txtMaterialNEnvases.Text;
			dsMaterial.Tables[0].Rows[numero]["FechaCaducidad"] = this.txtMaterialCaducidad.Text;
			dsMaterial.Tables[0].Rows[numero]["Conservacion"] = this.txtMaterialConservacion.Text;

			//TODO. Cambiar esto al implementar la aceptaciones.
			dsMaterial.Tables[0].Rows[numero]["AceptacionID"] = 1;
			dsMaterial.Tables[0].Rows[numero].EndEdit();

			}catch(Exception ex){
				FM_Errores.MostrarError("MainForm:MaterialAcondicionamiento","No se puede modificar el material de acondicionamiento",ex);
			}
			
		}

		
		
		/// <summary>
		/// Carga datos iniciales del material de acondicionamiento
		/// </summary>
		bool CargarDatosMaterial(){
			
			try{
			conMaterial = new MySqlConnection("host="+this.dbhost+ ";port="+ this.dbport.ToString()+";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");
		 	dsMaterial = new System.Data.DataSet();
		 	
		 	adapMaterial = new MySqlDataAdapter();
		 	adapMaterial.SelectCommand = new MySqlCommand("SELECT * FROM materialacondicionamiento;",conMaterial);
		 	adapMaterial.Fill(dsMaterial,"Material");
		 	
		 			 	
		 	return true;
			}catch(MySqlException ex){
				FM_Errores.MostrarError("MaterialAcondicionamiento:MainForm","Error relacionado con base de datos",ex);
				return false;
			}catch(Exception e){
				FM_Errores.MostrarError("MaterialAcondicionamiento:MainForm","Error general. No se puede cargar la informacion de material de acondicionamiento",e);
				return false;
			}
			
		}
		
		/// <summary>
		/// Define la logica de actualizacion del Material aconidicionamiento
		/// </summary>
		private void CargarComandoUpdateMaterial(){
			adapMaterial.UpdateCommand = new MySqlCommand("Update materialacondicionamiento Set Nombre = ?Nombre, ProveedorID= ?ProveedorID, Lote=?Lote, FechaRecepcion=?FechaRecepcion, Cantidad=?Cantidad, NEnvases = ?NEnvases, FechaCaducidad=?FechaCaducidad, Conservacion=?Conservacion, AceptacionID=?AceptacionID WHERE AcondicionamientoID = ?AcondicionamientoID",conMaterial);
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?AcondicionamientoID", MySqlDbType.Int32);
			parm.SourceColumn = "AcondionamientoID";
			parm.SourceVersion = DataRowVersion.Original;
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?Nombre", MySqlDbType.VarChar,150);
			parm.SourceColumn = "Nombre";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?ProveedorID", MySqlDbType.Int32);
			parm.SourceColumn = "ProveedorID";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?Lote", MySqlDbType.VarChar,30);
			parm.SourceColumn = "Lote";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?FechaRecepcion", MySqlDbType.VarChar,45);
			parm.SourceColumn = "FechaRecepcion";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?Cantidad", MySqlDbType.Float);
			parm.SourceColumn = "Cantidad";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?NEnvases", MySqlDbType.Int32);
			parm.SourceColumn = "NEnvases";
			parm.SourceVersion = DataRowVersion.Current ;
		
			parm = adapMaterial.UpdateCommand.Parameters.Add("?FechaCaducidad", MySqlDbType.VarChar,45);
			parm.SourceColumn = "FechaCaducidad";
			parm.SourceVersion = DataRowVersion.Current ;
		
			parm = adapMaterial.UpdateCommand.Parameters.Add("?Conservacion", MySqlDbType.VarChar,300);
			parm.SourceColumn = "Conservacion";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.UpdateCommand.Parameters.Add("?AceptacionID", MySqlDbType.Int32);
			parm.SourceColumn = "AceptacionID";
			parm.SourceVersion = DataRowVersion.Current ;
		}
				

		/// <summary>
		/// Define la logica de borrado del material de acondiconamiento
		/// </summary>
		private void CargarComandoDeleteMaterial(){
			adapMaterial.DeleteCommand = new MySqlCommand("DELETE FROM materialacondicionamiento WHERE AcondicionamientoID = ?AcondicionamientoID",conMaterial);
			
			parm = adapMaterial.DeleteCommand.Parameters.Add("?AcondicionamientoID", MySqlDbType.Int32);
			parm.SourceColumn = "AcondicionamientoID";
			parm.SourceVersion = DataRowVersion.Original;
			
			
		}
		
		
		/// <summary>
		/// Define la logica de nuevos materiales de acondicionamiento
		/// </summary>
		private void CargarComandoInsertMaterial(){
			adapMaterial.InsertCommand = new MySqlCommand("Insert into materialacondicionamiento(AcondicionamientoID, Nombre, ProveedorID, Lote, FechaRecepcion, Cantidad, NEnvases, FechaCaducidad, Conservacion, AceptacionID) VALUES (?AcondicionamientoID,?Nombre, ?ProveedorID, ?Lote, ?FechaRecepcion, ?Cantidad, ?NEnvases, ?FechaCaducidad, ?Conservacion, ?AceptacionID)",conMaterial);
			
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?AcondicionamientoID", MySqlDbType.Int32);
			parm.SourceColumn = "AcondionamientoID";
			parm.SourceVersion = DataRowVersion.Original;
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?Nombre", MySqlDbType.VarChar,150);
			parm.SourceColumn = "Nombre";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?ProveedorID", MySqlDbType.Int32);
			parm.SourceColumn = "ProveedorID";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?Lote", MySqlDbType.VarChar,30);
			parm.SourceColumn = "Lote";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?FechaRecepcion", MySqlDbType.VarChar,45);
			parm.SourceColumn = "FechaRecepcion";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?Cantidad", MySqlDbType.Float);
			parm.SourceColumn = "Cantidad";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?NEnvases", MySqlDbType.Int32);
			parm.SourceColumn = "NEnvases";
			parm.SourceVersion = DataRowVersion.Current ;
		
			parm = adapMaterial.InsertCommand.Parameters.Add("?FechaCaducidad", MySqlDbType.VarChar,45);
			parm.SourceColumn = "FechaCaducidad";
			parm.SourceVersion = DataRowVersion.Current ;
		
			parm = adapMaterial.InsertCommand.Parameters.Add("?Conservacion", MySqlDbType.VarChar,300);
			parm.SourceColumn = "Conservacion";
			parm.SourceVersion = DataRowVersion.Current ;
			
			parm = adapMaterial.InsertCommand.Parameters.Add("?AceptacionID", MySqlDbType.Int32);
			parm.SourceColumn = "AceptacionID";
			parm.SourceVersion = DataRowVersion.Current ;

		}

		void MostrarPosicionMaterial(){
			lblPosMaterial.Text = (this.MaterialRecPosition+1) + 
									" de " + this.MaterialRecCount;
		}
		void GuardarModificacionesMaterial()
		{
			try
    			{
        			int Modificaciones;
        			Modificaciones = adapMaterial.Update(dsMaterial,"Material");
					dsMaterial.Clear();
        			adapMaterial.Fill(dsMaterial,"Material");
        			this.MaterialRecPosition=0;
        			this.MaterialRecCount = dsMaterial.Tables[0].Rows.Count;
        			this.CargarRegistroMaterial (this.MaterialRecPosition );
        			this.MostrarPosicionMaterial();

        			
        			FM_Errores.MostrarAviso("Actualizacion correcta","Actualizados "+Modificaciones+" materiales de acondicionamiento");
        			if( !AlertaLocal.registra_alerta("Actualizados "+Modificaciones+" materiales de acondicionamiento con el nivel de autorizacion " + this.currentlevel.ToString()))
					{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
					}

        			
				}catch (Exception ex){
					FM_Errores.MostrarError("Actualizacion","Error actualizando datos",ex);
        	    }
			
		}


		
		#endregion

		
		#region Metodos internos 
		void MainFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			SecLocal.logout(currentuser,currentid); // Hace Logout del sistema
		}

		
		/// <summary>
		/// Carga la informacion de conexion a la base de datos
		/// desde un fichero de configuracion XML externo
		/// </summary>
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}
		
		
		private void CargarConfiguracionGestion(){

			this.Provincia="madrid";
			this.Annus="2007";
			string[] prf;
		
			if ( this.GstPrefs.LeerFichero() )
			{
				prf = this.GstPrefs.CargarPreferenciasGestion();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 2: this.Provincia = prf[2]; break;
						case 3: this.Annus = prf[3]; break;
					}
				}
				this.GstPrefs.CerrarEntrada();

			}

		}
		
		void CargarListaMaterias(){
			string[] mats;
			mats = Materia_rutinas.get_list_materias("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");
			for( int i = 0; i< mats.Length; ++i)
				this.lstMaterias.Items.Add(mats[i]);
				
		}
		
		
		/// <summary>
		/// Carga la configuracion de la base de datos y algunos datos 
		/// importantes de las pestaas de inicio
		/// </summary>
		void MainFormLoad(object sender, System.EventArgs e)
		{
			string[] instanceInfos; // Informacion de la instancia actual de la aplicacion
			this.Text += "v"+Application.ProductVersion;
			
			
			this.CargarConfiguracionDatabase();
			this.CargarConfiguracionGestion();
			
			// Asignacion de parametros de conexion para el objeto 
			// local de FarmaAuthorize
			SecLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
			AlertaLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
		
			// Se carga la informacion de la instancia del programa:
			// Quien y con que autorizacion ha iniciado el programa
			instanceInfos = SecLocal.GetInstanceInfo(currentid);
			this.txtUserName.Text = instanceInfos[0];
			this.currentuser = instanceInfos[0];
			this.currentlevel = Convert.ToInt32 (instanceInfos[1]);
			this.txtTipoUser.Text  = SecLocal.GetTypeUser ( Convert.ToInt32 (instanceInfos[1]) );
			this.CargarNombresUsuarios();
			this.CargarTiposUsuarios();
			
			
			// Cosas de control de calidad
			
			if ( this.CargarDatosControlCalidad() )
			{
				this.CargarComandoUpdateCalidad();
				this.CargarComandoInsertCalidad();
				this.CargarComandoDeleteCalidad();
				
				
				this.ControlesRecCount = dsCalidad.Tables["Controles"].Rows.Count;
				this.EnsayosRecCount = dsCalidad.Tables["Ensayos"].Rows.Count;
//			    MostrarPosicionControles();
//			    this.CargarRegistroControles(0);
    			this.MostrarPosicionCalidad();
    			
			}
		
			// Carga cosas de Material de acondicionamiento
			if ( this.CargarDatosMaterial() )
			{
				this.CargarComandoUpdateMaterial();
				this.CargarComandoInsertMaterial();
				this.CargarComandoDeleteMaterial();

				this.MaterialRecCount = dsMaterial.Tables[0].Rows.Count;
				this.MaterialRecPosition = 0;
			    MostrarPosicionMaterial();
			    this.CargarRegistroMaterial(0);
    			
			}
			
			// Cargar datos materias primas
			
			this.CargarListaMaterias();    
		}
		
		#endregion

		#region Control de datos de usuarios

		/// <summary>
		/// Carga el combo de tipos de usuario con los existentes en la tabla
		/// de la base de datos
		/// </summary>
		void CargarTiposUsuarios(){
			string[] tiposusuarios;
			tiposusuarios = SecLocal.GetTipoUserList();
			for( int i= 0; i < tiposusuarios.Length; ++i)
				this.cmbTipoUser.Items.Add ( tiposusuarios[i]);
		}
		
		/// <summary>
		/// Carga los nombres de los usuarios en un control tipo lista
		/// para que se pueda seleccionar individualmente cada uno y obtener
		/// asi la informacion mas detallada en el modo ficha.
		/// </summary>
		void CargarNombresUsuarios()
		{
			string [] usuarios;
			usuarios = SecLocal.GetUsersList();
			this.lstUsersDisplay.Items.Clear();
			for(int i = 0; i < usuarios.Length; ++i)
				this.lstUsersDisplay.Items.Add(usuarios[i]);
			
		}
		
		/// <summary>
		/// Carga la informacin de un usuario en las cajas 
		/// de texto del formulario para su visualizacion
		/// </summary>
		/// <param name="username">Usuario a cargar</param>
		void CargarInformacionUsuarios(string username){
			MySqlConnection conn = new MySqlConnection("host="+this.dbhost+";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");
			MySqlDataReader MyReader = null;
			try 
			{
			MySqlCommand cmd = new MySqlCommand("SELECT * FROM personal WHERE Usuario LIKE '"+username+"'", conn);
			
			conn.Open();
				MyReader = cmd.ExecuteReader();
				while( MyReader.Read() )
				{
					this.cmbTipoUser.Text = SecLocal.GetTypeUser ( Convert.ToInt32 ( MyReader.GetString (1)) );
					this.txtNombreUser.Text  = MyReader.GetString(2);
					this.txtApellidosUser.Text = MyReader.GetString(3);
					this.txtidUser.Text = MyReader.GetString(4);
					if( System.IO.File.Exists( MyReader.GetString(6)) )
						this.pctLogo.Image = Image.FromFile(MyReader.GetString(6));
					else
						this.pctLogo.Image = null;
					
				}
				MyReader.Close();
				conn.Close();
		
			}
			catch (MySqlException ex) 
			{
				FM_Errores.MostrarError("MainForm","No se puede conectar con la base de datos para conseguir la informacion del usuario",ex);
				return;
			}catch( Exception e){
				FM_Errores.MostrarError("MainForm","Error cargando la informacin del usuario",e);
				return;
			}
		}
		
		#endregion
		
		#region Callbacks de gestion de personal
		
		void lstUserDisplay_SelectedIndex(object sender, System.EventArgs e)
		{
			// Se asegura de que no se haya pinchado en un punto en blanco
			if ( this.lstUsersDisplay.SelectedIndex >= 0) 
			CargarInformacionUsuarios(this.lstUsersDisplay.SelectedItem.ToString());
		}
		
				void BtnEliminarUserClick(object sender, System.EventArgs e)
		{
			
			int l; 
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(51); // Modulo 5: Personal, accion 1: Borrar
			
			if(	this.currentlevel < l ){
				// TODO. Registrar una alerta de intento de sobrepasar seguridad
				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite borrar usuarios");
				return;
			}

			
			if ( this.lstUsersDisplay.SelectedIndex < 0) 
				FM_Errores.MostrarError("Error de usuarios","No ha seleccionado ningn usuario");
			else if( this.lstUsersDisplay.SelectedItem.ToString().CompareTo(this.currentuser) == 0){
				FM_Errores.MostrarError("Error de usuarios", "No puede borrar el usuario en uso acutalmente");
			}else{
						
				if ( MessageBox.Show( "Esta seguro de eliminar a este usuario?. Sus acciones en el registro sern asimiladas a desconocido", "Confirmar eliminacin",
			                     MessageBoxButtons.YesNo ) == DialogResult.Yes  )
				{
					if ( SecLocal.DeleteUser(this.lstUsersDisplay.SelectedItem.ToString()) )
						FM_Errores.MostrarAviso("Informacion","Usuario borrado correctamente");
					else
						FM_Errores.MostrarError("Error borrando el usuario");
					
					this.CargarNombresUsuarios();
				}
			}
		}

		
		
		#endregion
		
		#region Callbacks de menu

		void MenuAboutClick(object sender, System.EventArgs e)
		{
			AboutFormulacion ab1 = new AboutFormulacion();
			ab1.ShowDialog();
			ab1.Dispose();
		}
		
		void MenuEtiquetasClick(object sender, System.EventArgs e)
		{
			try{
				Editor ed1 = new Editor();
				ed1.ShowDialog();
				ed1.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarEditor","No se puede mostrar el editor",ex);
			}
		}

		
		void MenuGPacienteClick(object sender, System.EventArgs e)
		{
			FormulacionMagistral.PacientesForm pac1 = new PacientesForm(this.currentid );
			pac1.ShowDialog();
			pac1.Dispose();
		}
		
		void MenuGMAcondiClick(object sender, System.EventArgs e)
		{
			this.tabMain.SelectedIndex = 2;
		}

		
		void menuConfig_Click(object sender, System.EventArgs e)
		{
			ConfiguracionForm configForm = new ConfiguracionForm();
			configForm.Show();
		}

		void MenuGPersonalClick(object sender, System.EventArgs e)
		{
			this.tabMain.SelectedIndex = 3; // Selecciona el tab de personal
		}
		
		
		void MenuSalirClick(object sender, System.EventArgs e)
		{
			this.Close(); //Cierra el formulario principal
		}
		
		
		
		void MenuGFacultativoClick(object sender, System.EventArgs e)
		{
			
			int l; 
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(44); // Modulo 4: Facultativos, accion 4: Ver
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar acceder a facultativos con el nivel de autorizacion " + this.currentlevel.ToString() + " el usuario " + this.currentuser))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}
				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite acceder a los datos");
				return;
			}

			
			
			FacultativosForm facus = new FacultativosForm(currentlevel);
			facus.ShowDialog();
			facus.Dispose();
		}
		
		void MenuGProveedorClick(object sender, System.EventArgs e)
		{
			int l; 
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(34); // Modulo 3: Proveedores, accion 4: Ver
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar acceder a proveedores con el nivel de autorizacion " + this.currentlevel.ToString() + " el usuario " + this.currentuser))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}
				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite acceder a los datos");
				return;
			}
			//ProveedoresFormGeneral prov = new ProveedoresFormGeneral(currentlevel);
			ProveedoresForm prov = new ProveedoresForm(currentlevel);
			prov.ShowDialog();
			prov.Dispose();
		}

		void MenuAssistClick(object sender, System.EventArgs e)
		{
			Formulacion.FarmakitoForm fk = new Formulacion.FarmakitoForm();
			fk.ShowDialog();
		}
		
		void MenuGCalidadClick(object sender, System.EventArgs e)
		{
			this.tabMain.SelectedIndex = 1;
		}

		
		
		#endregion
		
		
		#region Callbacks de control de calidad
		
		
		void BtnNuevoEnyClick(object sender, System.EventArgs e)
		{
		//	cmCalidadEny.AddNew();
		}
		
		void BtnFirstCrtClick(object sender, System.EventArgs e)
		{
		//	cmCalidad.Position = 0;
		}
		
		void BtnPrevCtrClick(object sender, System.EventArgs e)
		{
		//	cmCalidad.Position--;
		}
		
		void BtnNextCrtClick(object sender, System.EventArgs e)
		{
		//	cmCalidad.Position++;
		}
		
		void BtnLastCtrClick(object sender, System.EventArgs e)
		{
		//	cmCalidad.Position = cmCalidad.Count -1;
		}
		
		void BtnBorrarEnyClick(object sender, System.EventArgs e)
		{
			if (MessageBox.Show("Esta seguro?", "Confirmacin", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
				return;
			
		/*	if (cmCalidadEny.Count > 0)
        		cmCalidadEny.RemoveAt(cmCalidadEny.Position);
    		else
    			FM_Errores.MostrarError("Error Control de calidad","No hay ensayos en la base de datos");*/
		}
		
		void BtnGuardarEnyClick(object sender, System.EventArgs e)
		{
			try{
//			cmCalidadEny.EndCurrentEdit();
			adapEnsayos.Update(dsCalidad, "Ensayos");
			}catch(Exception ex){
				FM_Errores.MostrarError("Error actualizando ensayos","Error",ex);
			}
			
		}
		
		void BtnNuevoControlClick(object sender, System.EventArgs e)
		{
//			cmCalidad.AddNew();
		}
		
		void BtnBorrarControlClick(object sender, System.EventArgs e)
		{
//			cmCalidad.RemoveAt (cmCalidad.Position);
		}
		
		void BtnSaveCrtClick(object sender, System.EventArgs e)
		{
			// TODO Cambiar el valor arbitrario por otro configurable
			if(	this.currentlevel < 0 ){
				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite modificar los datos");
				return;
			}
//			cmCalidad.EndCurrentEdit();
			if( dsCalidad.HasChanges() ){
				GuardarModificaciones();
			}
		}
		
		
		#endregion
		
		#region Callbacks de gestion de material de acondicionamiento
		
		void BtnMaterialImprimirClick(object sender, System.EventArgs e)
		{
			ImprimirMaterial();
		}

		void BtnMaterialImpListadoClick(object sender, System.EventArgs e)
		{
			ImprimirMaterialListado();
		}

		
		void BtnMaterialProveedorClick(object sender, System.EventArgs e)
		{
			try{
				int prvid;
				prvid = Convert.ToInt32 (this.txtMaterialProveedor.Text );
				ProveedoresForm prvdlg = new ProveedoresForm(this.currentid, prvid);
				prvdlg.ShowDialog();
				prvdlg.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MainForm: Material Acondicionamiento","No se puede abrir la ventana de proveedores",ex);
			}
		}
		
		
		void BtnMaterialFirstClick(object sender, System.EventArgs e)
		{
			this.MaterialRecPosition = 0;
			this.MostrarPosicionMaterial();
			this.CargarRegistroMaterial(this.MaterialRecPosition);			
		}
		
		void BtnMaterialPrevClick(object sender, System.EventArgs e)
		{
			if( this.MaterialRecPosition > 0)
			this.MaterialRecPosition--;
			this.MostrarPosicionMaterial();
			this.CargarRegistroMaterial(this.MaterialRecPosition);
		}
		
		void BtnMaterialNextClick(object sender, System.EventArgs e)
		{
			if( this.MaterialRecPosition < this.MaterialRecCount-1)
			this.MaterialRecPosition++;
			this.MostrarPosicionMaterial();
			this.CargarRegistroMaterial(this.MaterialRecPosition);
		}
		
		void BtnMaterialLastClick(object sender, System.EventArgs e)
		{
			this.MaterialRecPosition = this.MaterialRecCount-1;
			this.MostrarPosicionMaterial();
			this.CargarRegistroMaterial(this.MaterialRecPosition);
		}
		
		void BtnMaterialNuevoClick(object sender, System.EventArgs e)
		{
			int l; // Nivel para nuevo
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(71); // Modulo 7: Material Acondicionamiento, accion 2: Nuevo
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar aadir datos de material de acondicionamiento con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}
				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin es inferior a " + l.ToString() + " y no le permite aadir datos");
				return;
			}
			
			dsMaterial.Tables[0].Rows.Add(new Object[dsMaterial.Tables[0].Columns.Count]);
			this.MaterialRecCount = dsMaterial.Tables[0].Rows.Count;
			this.MaterialRecPosition = this.MaterialRecCount-1;
			
			this.MostrarPosicionMaterial();
			this.CargarRegistroMaterial(this.MaterialRecPosition);
		}
		
		void BorradoMaterial(object sender, System.Data.DataRowChangeEventArgs e)
		{
			DataRow[] pendientes;
			try{
			pendientes = dsMaterial.Tables[0].Select("", "", DataViewRowState.Deleted);
			FM_Errores.MostrarAviso("Borrado","Se han borrado " + adapMaterial.Update(pendientes).ToString() + " registros");
					dsMaterial.Clear();
        			adapMaterial.Fill(dsMaterial,"Material");
        			this.MaterialRecPosition=0;
        			this.MaterialRecCount = dsMaterial.Tables[0].Rows.Count;
        			this.CargarRegistroMaterial (this.MaterialRecPosition );
        			this.MostrarPosicionMaterial();

			}catch(Exception ex){
				FM_Errores.MostrarError("MainForm: Material acondicionamiento","No se puede borrar",ex);
			}
		}


		
		
		void BtnMaterialBorrarClick(object sender, System.EventArgs e)
		{
			int l; // Nivel para borrar 
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(41); // Modulo 7: Material acondicionamiento, accion 1: Borrar
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar borrar datos de material de acondicionamiento con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}
				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite borrar los datos");
				return;
			}
			
			
			if (MessageBox.Show("Esta seguro?", "Confirmacin", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
				return;
			
			try{
			dsMaterial.Tables[0].RowDeleted += new System.Data.DataRowChangeEventHandler(BorradoMaterial);
			dsMaterial.Tables[0].Rows.RemoveAt( this.MaterialRecPosition);
			}catch(Exception ex){
				FM_Errores.MostrarError("MainForm: Material Acondicionamiento","No se puede borrar el material de acondicionamiento",ex);
			}

		}
		
		void BtnMaterialGuardarClick(object sender, System.EventArgs e)
		{
			int l; // Nivel para guardar
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(73); // Modulo 7: Material Acondicionamiento, accion 3: Modificar
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar modificar los datos de material de acondicionamiento con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite modificar los datos");
				return;
			}
			
			    GuardarRegistroMaterial(this.MaterialRecPosition);
				GuardarModificacionesMaterial();
		}


		#endregion
		
		
		void TabMainClick(object sender, System.EventArgs e)
		{
			
		}
		
		#region Impresion de Material de acondicionamiento


		
		
		private void ImprimirMaterial()
		{

			Formulacion.Impresiones docMaterial = new Formulacion.Impresiones();
			PrintDialog prdialog = new PrintDialog();
			PrintPreviewDialog prevDialog = new PrintPreviewDialog();

			docMaterial.ImprimirCabezera();
			docMaterial.NuevoTexto("DETALLE DEL REGISTRO DE MATERIAL DE ACONDICIONAMIENTO");
			docMaterial.NuevoTexto("");
			docMaterial.NuevoTexto("Material de Acondicionamiento ID: " + this.txtMaterialID.Text );
			docMaterial.NuevoTexto("Nombre del Material: " + this.txtMaterialProducto.Text);
			docMaterial.NuevoTexto("Lote: " + this.txtMaterialLote.Text);
			docMaterial.NuevoTexto("N de Envases: " + 	this.txtMaterialNEnvases.Text);
			docMaterial.NuevoTexto("Cantidad: " + this.txtMaterialCantidad.Text);
			docMaterial.NuevoTexto("");
			docMaterial.NuevoTexto("ID del Proveedor: " + this.txtMaterialProveedor.Text);
			docMaterial.NuevoTexto("Fecha de Recepcion: " + this.txtMaterialFechaRecepcion.Text);
			docMaterial.NuevoTexto("Fecha de Caducidad: " + this.txtMaterialCaducidad.Text);
			docMaterial.NuevoTexto("");
			docMaterial.NuevoTexto("Instrucciones de conservacion: " + this.txtMaterialConservacion.Text);
				
			prdialog.Document = docMaterial;
			prevDialog.Document = docMaterial;

			docMaterial.PrintPage += new PrintPageEventHandler(docMaterial.ImprimirElementos);
			
			prevDialog.ShowDialog();
			if (prdialog.ShowDialog()== DialogResult.OK)
			{
				docMaterial.Print();
			}

			}

		private void ImprimirMaterialListado()
		{
			
			Formulacion.Impresiones docMaterial = new Formulacion.Impresiones();
			PrintDialog prdialog = new PrintDialog();
			PrintPreviewDialog prevDialog = new PrintPreviewDialog();

			
			docMaterial.ImprimirCabezera();
			docMaterial.NuevoTexto("Listado de Material de acondicionamiento");

			object[] a;
			
			for(int i=0 ; i<dsMaterial.Tables[0].Rows.Count;++i)
			{
			a = dsMaterial.Tables[0].Rows[i].ItemArray;
			docMaterial.NuevaLinea();
			docMaterial.NuevoTexto("Material de Acondicionamiento ID: " + a[0].ToString());
			docMaterial.NuevoTexto("Nombre del Material: " + a[1].ToString());
			docMaterial.NuevoTexto("Lote: " + a[4].ToString());
			docMaterial.NuevoTexto("N de Envases: " + 	a[7].ToString());
			docMaterial.NuevoTexto("Cantidad: " + a[6].ToString());
			docMaterial.NuevoTexto("");
			docMaterial.NuevoTexto("ID del Proveedor: " + a[3].ToString());
			docMaterial.NuevoTexto("Fecha de Recepcion: " + a[5].ToString());
			docMaterial.NuevoTexto("Fecha de Caducidad: " + a[8].ToString());
			docMaterial.NuevoTexto("");
			docMaterial.NuevoTexto("Instrucciones de conservacion: " + a[2].ToString());
			docMaterial.NuevoTexto("");
			
			}
			
			prdialog.Document = docMaterial;
			prevDialog.Document = docMaterial;

			docMaterial.PrintPage += new PrintPageEventHandler(docMaterial.ImprimirElementos);
			
			prevDialog.ShowDialog();
			if (prdialog.ShowDialog()== DialogResult.OK)
			{
				docMaterial.Print();
			}

			
			
		}
		#endregion
		
		
		void BtnMaterialAceptacionesClick(object sender, System.EventArgs e)
		{
			try{
			AceptacionesForm af = new AceptacionesForm(this.currentlevel, Convert.ToInt32( dsMaterial.Tables[0].Rows[this.MaterialRecPosition]["AceptacionID"]));
			af.ShowDialog();
			af.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarAceptaciones","No se puede mostrar el visor de aceptaciones",ex);
			}
		}
		
		void BtnUserNewClick(object sender, System.EventArgs e)
		{
			try{
			PersonalMiniVista pmv = new PersonalMiniVista(this.currentlevel, -1);
			pmv.ShowDialog();
			pmv.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MainForm","No se puede mostrar la informacin de personal",ex);
			}

		}
		
		void BtnUserSaveClick(object sender, System.EventArgs e)
		{
			try{
			PersonalMiniVista pmv = new PersonalMiniVista(this.currentlevel,-1);
			pmv.ShowDialog();
			pmv.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MainForm","No se puede mostrar la informacin de personal",ex);
			}

		}
		
		void MenuTasarClick(object sender, System.EventArgs e)
		{
			try{
			Dispensacion ds1 = new Dispensacion(this.currentlevel, this.currentuser);
			ds1.ShowDialog();
			ds1.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarTasacion","No se puede mostrar el modulo de tasacion",ex);
			}
		}
		
		void MenuVisorAlertasClick(object sender, System.EventArgs e)
		{
			try{
			VisorAlertas va1 = new VisorAlertas(this.currentlevel);
			va1.ShowDialog();
			va1.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarAlertas","No se puede mostrar el visor de alertas",ex);
			}
		}
		
		void MenuEnvasesClick(object sender, System.EventArgs e)
		{
			try{
			EnvasesForm evf = new EnvasesForm(this.currentlevel, this.Provincia, this.Annus);
			evf.ShowDialog();
			evf.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarEnvases","No se pueden mostrar los envases",ex);
			}
		}
		
		void MenuGFormulasClick(object sender, System.EventArgs e)
		{
			try{
			FormulasForm ffm = new FormulasForm(this.currentlevel);
			ffm.ShowDialog();
			ffm.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("MostrarFormulas","No se pueden mostrar las formulas",ex);
			}
		}
		
		void TabMaterialClick(object sender, System.EventArgs e)
		{
			
		}
		
		void MenuSubGRegistroClick(object sender, System.EventArgs e)
		{
			try{
			MateriasForm reg1 = new MateriasForm(this.currentlevel);
			reg1.ShowDialog();
			reg1.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("Mostrar Registro","No se puede mostrar el registro de materias primas",ex);
			}
		}
		
		void MenuSubGEspecificacionClick(object sender, System.EventArgs e)
		{
			this.tabMain.SelectedIndex = 0;
		}
		
		void CargarInformacionMateriaExtendida(string materia){
			
		}
		
		
		void CargarInformacionMateria(string materia){
			
			try{
			string matid;
			string[] sins;
			string[] espes;
			
			// Saca el ID de la materia prima.
			matid = Materia_rutinas.get_materiaid("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion", materia);

			// Saca y carga los sinonimos asociados.
			sins = Materia_rutinas.get_sinonimos("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion",matid);
			this.lstSinonimos.Items.Clear();
			for( int i = 0; i< sins.Length; ++i)
				this.lstSinonimos.Items.Add(sins[i]);
			
			// Cargar el resto de datos de Especificaciones de Materias primas
			
			espes = Materia_rutinas.get_especificaciones("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion",matid);
			this.txtDefincion.Text = espes[1];
			this.txtCaracteres.Text = espes[2];
			this.txtIndicaciones.Text = espes[3];
			this.txtPropiedades.Text = espes[4];
			this.txtContraindicaciones.Text = espes[5];
			this.txtConservacion.Text = espes[6];
			this.txtObservaciones.Text = espes[8];
			this.txtPrecio.Text = espes[9];
			this.txtMateriaID.Text = matid;
			this.txtDOE.Text = materia;
	
			
			}catch(Exception ex){
				FM_Errores.MostrarError("CargarInformacionMateria","No se puede cargar la informacion asociada la materia prima",ex);
			}

		}
		
		void LstMateriasSelectedIndexChanged(object sender, System.EventArgs e)
		{
			if ( this.lstMaterias.SelectedIndex >= 0)
			CargarInformacionMateria(this.lstMaterias.SelectedItem.ToString());

		}
		
		void BtnSinNuevoClick(object sender, System.EventArgs e)
		{
			try{
			GenericInputForm gif1 = new GenericInputForm("Nuevo sinonimo","Sinonimo");
			gif1.ShowDialog();
			if( gif1.result != 0){
				// TODO. Meter el sinonimo en la base de datos con gif1.answer
			}
			gif1.Dispose();
			}catch(Exception ex){
				FM_Errores.MostrarError("NuevoSinonimo","No se puede aadir un sinonimo",ex);
			}
		}
		
	}
}
