/*
 * 
 * 
 * Materias List
 * 
 * (C) Alvaro Cortes. 2007. alvarocortesc@gmail.com
 * 
 * 
 * 
 * 
 */

using System;
using System.Drawing;
using System.Windows.Forms;

using System.Drawing.Printing;
using MySql.Data.MySqlClient;
using System.Data;


namespace FormulacionMagistral
{
	/// <summary>
	/// Description of MateriasList.
	/// </summary>
	public class MateriasList : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnCerrar;
		private System.Windows.Forms.Button btnLast;
		private System.Windows.Forms.TextBox txtMateriaID;
		private System.Windows.Forms.Label lblPos;
		private System.Windows.Forms.TextBox txtDOE;
		private System.Windows.Forms.Label lblDOE;
		private System.Windows.Forms.Button btnPrev;
		private System.Windows.Forms.Button btnFirst;
		private System.Windows.Forms.Button btnNext;
		private System.Windows.Forms.Label lblMateriaID;
		

		private MySqlConnection conn;
		private MySqlDataAdapter adap;  
		private System.Data.DataSet ds;
		
	
		// Algunas variables para emular el CurrencyManager defectuoso de Mono
		private int RecCount;
		private int RecPosition;
				
		// Para cargar preferencias de la BD
		private Formulacion.PreferenciasDB DBPrefs;
		
		// Informacion para conexion BD
		private string dbhost;
		private string dbport;
		private string dbuser;
		private string dbpasoteword;
		
		
		
		// Nivel de acceso
		private int currentlevel;
		private Alertas AlertaLocal; // Alertas
		
		
		/// <summary>
		/// Constructor 
		/// </summary>
		/// <param name="nivel">Nivel de autorizacion</param>
		public MateriasList(int nivel)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			
			this.currentlevel = nivel;
			this.RecPosition = -1;
			
			AlertaLocal = new Alertas();
		}

		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="nivel">Nivel de acceso</param>
		/// <param name="registro">ID de la materia a cargar</param>
		public MateriasList(int nivel, int registro)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			
			this.currentlevel = nivel;
			this.RecPosition = registro;
			
			AlertaLocal = new Alertas();
		}
		
		/// <summary>
		/// Obtiene el id del registro actual
		/// </summary>
		/// <returns>Devuelve un entero del ID del registro</returns>
		public int getcurrentid(){
			int n;
			try{
				n = Convert.ToInt32( this.txtMateriaID.Text);
				return n;
			}catch(Exception ex){
				FM_Errores.MostrarError("GetCurrentID","No se puede obtener el ID actual",ex);
				return -1;
			}
		}

		
		/// <summary>
		/// Carga la configuracin de la base de datos en la vars
		/// de la clase
		/// </summary>
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}

		private bool Conectar(int registro){
			try{
		 	conn = new MySqlConnection("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");
		 	adap = new MySqlDataAdapter();
			ds = new System.Data.DataSet();
			if( registro >= 0){
		 		adap.SelectCommand = new MySqlCommand("SELECT * FROM materia WHERE MateriaID="+ registro.ToString() + ";",conn);
			}
		 	else{
		 	adap.SelectCommand = new MySqlCommand("SELECT * FROM materia;",conn);
				}
			adap.Fill(ds,"Materias");
		 	
		 	return true;
			}catch(MySqlException ex){
				FM_Errores.MostrarError("MateriasList","Error relacionado con base de datos",ex);
				return false;
			}catch(Exception e){
				FM_Errores.MostrarError("MateriasList","Error general. No se puede cargar la informacion de materias primas",e);
				return false;
			}
		 	
		}
		
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.lblMateriaID = new System.Windows.Forms.Label();
			this.btnNext = new System.Windows.Forms.Button();
			this.btnFirst = new System.Windows.Forms.Button();
			this.btnPrev = new System.Windows.Forms.Button();
			this.lblDOE = new System.Windows.Forms.Label();
			this.txtDOE = new System.Windows.Forms.TextBox();
			this.lblPos = new System.Windows.Forms.Label();
			this.txtMateriaID = new System.Windows.Forms.TextBox();
			this.btnLast = new System.Windows.Forms.Button();
			this.btnCerrar = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblMateriaID
			// 
			this.lblMateriaID.Location = new System.Drawing.Point(24, 32);
			this.lblMateriaID.Name = "lblMateriaID";
			this.lblMateriaID.Size = new System.Drawing.Size(104, 16);
			this.lblMateriaID.TabIndex = 0;
			this.lblMateriaID.Text = "Materia ID";
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(216, 104);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(32, 24);
			this.btnNext.TabIndex = 6;
			this.btnNext.Text = "->";
			this.btnNext.Click += new System.EventHandler(this.BtnNextClick);
			// 
			// btnFirst
			// 
			this.btnFirst.Location = new System.Drawing.Point(80, 104);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.Size = new System.Drawing.Size(32, 24);
			this.btnFirst.TabIndex = 4;
			this.btnFirst.Text = "|<-";
			this.btnFirst.Click += new System.EventHandler(this.BtnFirstClick);
			// 
			// btnPrev
			// 
			this.btnPrev.Location = new System.Drawing.Point(112, 104);
			this.btnPrev.Name = "btnPrev";
			this.btnPrev.Size = new System.Drawing.Size(32, 24);
			this.btnPrev.TabIndex = 5;
			this.btnPrev.Text = "<-";
			this.btnPrev.Click += new System.EventHandler(this.BtnPrevClick);
			// 
			// lblDOE
			// 
			this.lblDOE.Location = new System.Drawing.Point(24, 72);
			this.lblDOE.Name = "lblDOE";
			this.lblDOE.Size = new System.Drawing.Size(104, 16);
			this.lblDOE.TabIndex = 1;
			this.lblDOE.Text = "DOE";
			// 
			// txtDOE
			// 
			this.txtDOE.Enabled = false;
			this.txtDOE.Location = new System.Drawing.Point(136, 64);
			this.txtDOE.Name = "txtDOE";
			this.txtDOE.Size = new System.Drawing.Size(232, 20);
			this.txtDOE.TabIndex = 3;
			this.txtDOE.Text = "";
			// 
			// lblPos
			// 
			this.lblPos.Location = new System.Drawing.Point(144, 104);
			this.lblPos.Name = "lblPos";
			this.lblPos.Size = new System.Drawing.Size(72, 24);
			this.lblPos.TabIndex = 8;
			this.lblPos.Text = "0 de 0";
			this.lblPos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtMateriaID
			// 
			this.txtMateriaID.Enabled = false;
			this.txtMateriaID.Location = new System.Drawing.Point(136, 24);
			this.txtMateriaID.Name = "txtMateriaID";
			this.txtMateriaID.Size = new System.Drawing.Size(232, 20);
			this.txtMateriaID.TabIndex = 2;
			this.txtMateriaID.Text = "";
			// 
			// btnLast
			// 
			this.btnLast.Location = new System.Drawing.Point(248, 104);
			this.btnLast.Name = "btnLast";
			this.btnLast.Size = new System.Drawing.Size(32, 24);
			this.btnLast.TabIndex = 7;
			this.btnLast.Text = "->|";
			this.btnLast.Click += new System.EventHandler(this.BtnLastClick);
			// 
			// btnCerrar
			// 
			this.btnCerrar.Location = new System.Drawing.Point(304, 104);
			this.btnCerrar.Name = "btnCerrar";
			this.btnCerrar.Size = new System.Drawing.Size(72, 24);
			this.btnCerrar.TabIndex = 9;
			this.btnCerrar.Text = "Cerrar";
			this.btnCerrar.Click += new System.EventHandler(this.BtnCerrarClick);
			// 
			// MateriasList
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(402, 143);
			this.Controls.Add(this.btnCerrar);
			this.Controls.Add(this.lblPos);
			this.Controls.Add(this.btnLast);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnPrev);
			this.Controls.Add(this.btnFirst);
			this.Controls.Add(this.txtDOE);
			this.Controls.Add(this.txtMateriaID);
			this.Controls.Add(this.lblDOE);
			this.Controls.Add(this.lblMateriaID);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.Name = "MateriasList";
			this.Text = "Materias primas";
			this.Load += new System.EventHandler(this.MateriasListLoad);
			this.ResumeLayout(false);
		}
		#endregion
		void MateriasListLoad(object sender, System.EventArgs e)
		{
			this.CargarConfiguracionDatabase();
			AlertaLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
			if ( this.Conectar(this.RecPosition) )
			{
				this.RecPosition = 0;
				this.RecCount = ds.Tables[0].Rows.Count;
			    MostrarPosicion();
			    this.CargarRegistro(0);
			}

		}
		
		void MostrarPosicion(){
			this.lblPos.Text = (this.RecPosition+1).ToString() + " de " + this.RecCount.ToString();
		}

		void CargarRegistro( int numero){
			
			
			if( numero >=0 && numero < ds.Tables[0].Rows.Count)
			{
				string[] res;
				this.txtMateriaID.Text = ds.Tables[0].Rows[numero]["MateriaID"].ToString();
				this.txtDOE.Text = ds.Tables[0].Rows[numero]["DOE"].ToString();
			}
		}

		
		void BtnFirstClick(object sender, System.EventArgs e)
		{
			this.RecPosition = 0;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnPrevClick(object sender, System.EventArgs e)
		{
			if( this.RecPosition > 0)
			this.RecPosition--;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnNextClick(object sender, System.EventArgs e)
		{
			if( this.RecPosition < this.RecCount-1)
			this.RecPosition++;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnLastClick(object sender, System.EventArgs e)
		{
			this.RecPosition = this.RecCount-1;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnCerrarClick(object sender, System.EventArgs e)
		{
			this.Close();
		}
		
	}
}
